// ********************************************************************
//
//  Routine:      acReadGlobalByKey
//  Author:       T.Oest
//
//  Description:  read global alignment constants from database
//                using the event key
//
//  Modification:
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>
#include <limits.h>
#include "arte/arte.hh"
#include "database/table.h"
#include "database/keytable.h"

#include "online/esp.h"


static int GlobalAlignServer = -1;
static int ACGAtable = -1;

void ackuexec(char * KuipCommand);


//*****************************************************************
// function
//*****************************************************************

int acReadGlobalByKey(int KTstatus, char * dbserver) {

 int ACGAupdate = 0;

//==================================================================
// get update information from key table
//==================================================================

 switch (KTstatus) {

 case 2:

  GlobalAlignServer = KeyFindServer(dbserver);
  if (GlobalAlignServer == -1 ) return -1;

  ACGAtable = KeyFindTable(GlobalAlignServer, "ACGA");
  if (ACGAtable == -1 ) return -2;


 case 1:

  if (!KeyTableNew(ACGAtable)) return 0;


   int major = KeyTableMajor(ACGAtable);
   int minor = KeyTableMinor(ACGAtable);

//==================================================================
// read in new ACGA table if table not existing or update necessay
//==================================================================

   char LunName[5] = {'D','B','G','A',0};
   char * KuipCommand =  (char*) malloc(max(128,
                                       int(24+strlen(dbserver))));


   sprintf (KuipCommand,"dbopen %s ro",LunName);
   ackuexec(KuipCommand);

   ArteTable<ACGA>::clear();
   sprintf (KuipCommand,"dbread %s ACGA %i %i eq",LunName,major,minor);
   ackuexec(KuipCommand);

   sprintf (KuipCommand,"dbclose %s",LunName);
   ackuexec(KuipCommand);
   
   ACGAupdate = 1;


  break;

  };

//==================================================================
// check if ACGA table exist
//==================================================================

 if (ArteTable<ACGA>::size() == 0) ACGAupdate = -3;

 return ACGAupdate;
}
