*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE ATSTOP (CTXT)
************************************************************************
*
* Description: ARTE termination
*
* Called from: anywhere
*
* External references:
*
* Arguments in/out description
*   CTXT    in     text describing the reason for job termination.
*
************************************************************************

      IMPLICIT NONE
#include "arte/ArteSelect.fi"
#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEIO.fi"
#include "auto/MEMO.fi"

      INTEGER DUMMY, ACSTOP, FASTOP, RCSTOP, I
      REAL T
      CHARACTER*(*) CTXT
CAG      CHARACTER*20  C1,C2 

#include "arte/Arte.ff"
#include "auto/MEIO.ff"
#include "auto/MEMO.ff"

      IF (PROGSTAT .GT. 0)  THEN

C prevent recursive calls

        CALL MEALLP
     +    ('=== ATSTOP is called recursively: STOP immediately.')
        CALL MEALLP
     +    ('=== Program may not be properly terminated.')
        GO TO 90
      END IF

      CALL ZPHASE (-1)
      PROGSTAT = 1
      CALL TIMEX (T)
      TIMEEMAX = MAX (TIMEEMAX, T - TIMESTOP)
      TIMESTOP = T
      CALL LISTOP (CTXT)

C Users termination

      CALL USSTOP

C write and drop old event

      IF (JEVHD .NE. 0)  CALL MMWEVT

C Grafic termination

cc      IF (PRISINIT.NE.0) CALL IGEND
cc Call IGEND only if DRAW is ON
       IF (PRISINIT.NE.0) CALL ARTESELECT(I_DRAW,I_IGEND)

C RECO termination

      DUMMY = RCSTOP ()

C FARM termination

      DUMMY = FASTOP ()

C A&C termination

      DUMMY = ACSTOP ()

C HBOOK buffers:

      IF (IMEIO_FLAG(IMEIO_CURRENT(LHIST)) .GT. 0)  THEN
        CALL HROUT (0, DUMMY, 'T')
        CALL HREND ('ARTE')
        CALL MEWARC (876349, 'HBOOK file closed')
      END IF

C clear Zebra output buffers

      CALL FZENDO (0, 'TXQ')
      CALL MEWARC (7523434, 'Zebra output files closed')

C clear GPACK output buffers

      CALL GARTEND
      CALL MEWARC (7523435, 'GPACK output files closed')

C DbArteBridge termination

      CALL DBSTOP ()

C remove temporary STAGE files

CAG      C1 = 'DUMMY' (AG: 3 Jun 99)
CAG      C2 = 'DUMMY' (AG: 3 Jun 99)
CAG      CALL UTSTAGE( -1 , C1 , C2 ) (AG: 3 Jun 99)

C new: copy files to tape  T.Oest 26.2.99

      CALL ioosmtape() 

C Statistics

      DO I = 1, NMEMO()
        IF (JLINK(I) .NE. 0) THEN
          CALL MMSTATISTICS (I)
          IQ(IQMEMO_DROP(I)) = IQ(IQMEMO_DROP(I)) + 1
        END IF
      END DO

      
      CALL LITABL (0, 'L')
      CALL LIUNIT (0, 'L')
      CALL LIIOTA (0, 'L')
      CALL LISTATISTICS (0, 'L')
      CALL LIASTATISTICS (0, 'L')

C print message summary

      CALL LIMESS ('TPL')

C timing information

      CALL LITIME ('TPL')

      CALL MEALLP ('*-------------------------- ARTE: normal terminatio'
     + // 'n -------------------------')

      C78 = 'Job statistics can be found in file'
      CALL CH78BC (JOBNAME)
      CALL CH78AC ('.logf')
      CALL MESELP (' ', 'TP')
      CALL ME78SP ('TP')
      CALL MESELP (' ', 'TP')

 90   STOP

      END

************************************************************************
* End of ATSTOP
************************************************************************
