*CMZ :          17/01/97  17.01.42  by  Unknown
*-- Author :
      SUBROUTINE F0NLUX(ARRAY,XRAN,LEN)

* modified routine FUNLUX from CERNLIB 

C         Generation of LEN random numbers in any given distribution,
C         by 4-point interpolation in the inverse cumulative distr.
C         which was previously generated by FUNLXP

      COMMON/FUNINT/XUNI
      DIMENSION ARRAY(200)
      DIMENSION XRAN(LEN)
C  Bin width for main sequence, and its inverse
      PARAMETER (GAP= 1./99.,  GAPINV=99.)
C  Top of left tail, bottom of right tail (each tail replaces 2 bins)
      PARAMETER (TLEFT= 2./99.,BRIGHT=97./99.)
C  Bin width for minor sequences (tails), and its inverse
      PARAMETER (GAPS=TLEFT/49.,  GAPINS=1./GAPS)
C
C   The array ARRAY is assumed to have the following structure:
C        ARRAY(1-100) contains the 99 bins of the inverse cumulative
C                     distribution of the entire function.
C        ARRAY(101-150) contains the 49-bin blowup of main bins
C                       1 and 2 (left tail of distribution)
C        ARRAY(151-200) contains the 49-bin blowup of main bins
C                       98 and 99 (right tail of distribution)
C

         INTEGER  LENOCC 
         EXTERNAL LENOCC
         
         LOGICAL LFIRST 
         SAVE    LFIRST 
         DATA    LFIRST / .TRUE. /


      CALL GRNDM(XRAN,LEN)


      DO 500 IBUF= 1, LEN
      X = XRAN(IBUF)
      J = INT(  X    *GAPINV) + 1
      IF (J .LT. 3)  THEN
         J1 = INT( X *GAPINS)
             J = J1 + 101
             J = MAX(J,102)
             J = MIN(J,148)
         P = (   X -GAPS*(J1-1)) * GAPINS
         A = (P+1.0) * ARRAY(J+2) - (P-2.0)*ARRAY(J-1)
         B = (P-1.0) * ARRAY(J) - P * ARRAY(J+1)
         XRAN(IBUF) = A*P*(P-1.0)*0.16666667  + B*(P+1.0)*(P-2.0)*0.5
      ELSE IF (J .GT. 97)  THEN
         J1 = INT((X-BRIGHT)*GAPINS)
             J = J1 + 151
             J = MAX(J,152)
             J = MIN(J,198)
         P = (X -BRIGHT -GAPS*(J1-1)) * GAPINS
         A = (P+1.0) * ARRAY(J+2) - (P-2.0)*ARRAY(J-1)
         B = (P-1.0) * ARRAY(J) - P * ARRAY(J+1)
         XRAN(IBUF) = A*P*(P-1.0)*0.16666667  + B*(P+1.0)*(P-2.0)*0.5
      ELSE
CC      J = MAX(J,2)
CC      J = MIN(J,98)
         P = (   X -GAP*(J-1)) * GAPINV
         A = (P+1.0) * ARRAY(J+2) - (P-2.0)*ARRAY(J-1)
         B = (P-1.0) * ARRAY(J) - P * ARRAY(J+1)
         XRAN(IBUF) = A*P*(P-1.0)*0.16666667  + B*(P+1.0)*(P-2.0)*0.5
      ENDIF
  500 CONTINUE
      XUNI = X
      RETURN
      END
