//                              -*- Mode: C++ -*-
//: CmdCareStat.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#ifndef CMDCARESTAT_HH_
#define CMDCARESTAT_HH_

#include "care/CmdBase.hh" 

/**
class  CmdCareStat.
  Class to deal with the care/stat kuip command
*/

class CmdCareStat : public CmdBase {
public:
  /// Constructor
  CmdCareStat();
  /// Destructor
  virtual ~CmdCareStat();
  
  //-- Behavioural operations
  ///   Reset stored data to default values
  virtual void defValues();
  //--
  ///   Execute stored command
  virtual void execute();

# ifdef USEKUIP
  //--
  ///   Read a command from external source
  virtual void read();
# endif
  //--
  ///   Dump internal data
  virtual void dump();
  //
  /// Set internal data
  inline void setStat(unsigned int index, unsigned int status);

private:
  //
  //--
  unsigned int indx;
  unsigned int status;
};

void CmdCareStat::setStat(unsigned int index, unsigned int stat) {
  indx = index;
  status = stat;
}
#endif  //   CMDCARESTAT_HH_
