// ********************************************************************
//
//  Routine:      gageTraceTRACK
//  Author:       T. Oest
//
//  Description:  trace tracks
//
//  Modification:
//  -- return code included                             T.Oest 10/03/00
//
// ********************************************************************

// includes
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>
#include <complex.h>
#include "arte/arte.hh"


extern "C" {
 void rkmain_(const int    & icovar, 
              const double & zout, 
              const double & fstep, 
              const double * parameters, 
              const double * prec, 
              const double * p_track, 
              const double * derivatives, 
              const int    & ierror);
};
//
// function
//
int gageTraceTRACK(float z, float * pin, float * p)
{

     double       fstep;
     const int    icovar=2;
     int          ierror;
     double       prec[4];
     double       derivatives[5][5]={};
     double       pTrack[6], pOut[6];
     double       zout = double(z);

     pTrack[0] = double(pin[0]);
     pTrack[1] = double(pin[1]);
     pTrack[2] = double(pin[2]);
     pTrack[3] = double(pin[3]);
     pTrack[4] = double(pin[4]);
     pTrack[5] = double(pin[5]);

     prec[0]   = 0.001/abs(zout-pTrack[0]);
     prec[1]   = prec[0];
     prec[2]   = 0.0001/abs(zout-pTrack[0]);
     prec[3]   = prec[2];

     if (zout > pTrack[0] ) {
         fstep =  50.;
     } else {
         fstep = -50.;
     };

     if (zout != pTrack[0]){

      rkmain_(icovar, zout, fstep, pTrack, prec, pOut, 
              & derivatives[0][0], ierror);
      for (int i=0; i<6 ;i++)  p[i] = float(pOut[i]);

     } else {
      for (int i=0; i<6 ;i++)  p[i] = pin[i];
      ierror = 1;
     };

     return ierror;

};
