#include <string.h>
#include <math.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "gean/gclink.h"
#include "gean/Geant2Arte.hh"
#include "gean/ZGMOTH.h"

extern "C" {
    void crlvbk_(char * ,int &,int &,unsigned int &,char*,int[]);
    void glvolu_(int*,char*,int[],int*);
    void crvtrm_( unsigned int&, char*, int[], float[], float[]);    
}

unsigned int Geant2Arte::GetGvolNumber(char *volname) {
//      check whether the volume already exists
        ivos = 0;
        int nvol=*(gcbank_.iq + gclink_.jvolum -2);
        for(int i=0; i<nvol; i++) {
          if(!memcmp((gcbank_.iq+gclink_.jvolum+i),volname,4)) {
	     memcpy(name,volname,4);
             ivos = i+1;
             break; 
          }
        }
        return ivos;
}

void  Geant2Arte::SetGvolNumber(char *volname, int &iv) {
      memcpy(name,volname,4);
      ivos = iv;
}

unsigned int  Geant2Arte::CreateNede(){ 
//    Book NEDE bank and connect it to NESL bank 
      if(zgmoth_.CURRSL <= 0 || zgmoth_.CURRSL >ArteTable<NESL>::size() ) { 
         arteMsg << "CreateNede: current nesl entry = 0 "; arteMsg.error();
      }  
      ArtePointer<NESL> ns(zgmoth_.CURRSL);
      struct NEDE nede;   
      memset(&nede,0,sizeof(nede));
      ArteTable<NEDE>::push_back(nede); 
      unsigned int nnede = ArteTable<NEDE>::size();
      ArtePointer<NEDE> nd(nnede);
      createRelation(ns,nd,&NESL::nede);
      if(ns->fpl == 0) ns->fpl = nnede;   
      ns->npl = ns->npl + 1;
      nd->cmp = ns->cmp;
      return nnede;
}

unsigned int  Geant2Arte::CreateNwal(){ 
//    Book NWAL bank and connect it to NESL bank 
      if(zgmoth_.CURRSL <= 0 || zgmoth_.CURRSL >ArteTable<NESL>::size() ) { 
         arteMsg << "CreateNwal: current nesl entry = 0 "; arteMsg.error();
      }  
      ArtePointer<NESL> ns(zgmoth_.CURRSL);
      struct NWAL nwal;   
      memset(&nwal,0,sizeof(nwal));
      ArteTable<NWAL>::push_back(nwal); 
      unsigned int nnwal = ArteTable<NWAL>::size();
      ArtePointer<NWAL> nd(nnwal);
      createRelation(ns,nd,&NESL::nwal);
      if(ns->fwl == 0) ns->fwl = nnwal;   
      ns->nwl++;
      return nnwal;
}

unsigned int  Geant2Arte::CreateNcal(){ 
//    Book NCAL bank and connect it to NESL bank 
      if(zgmoth_.CURRSL <= 0 || zgmoth_.CURRSL >ArteTable<NESL>::size() ) { 
         arteMsg << "CreateNcal: current nesl entry = 0 "; arteMsg.error();
      }  
      ArtePointer<NESL> ns(zgmoth_.CURRSL);
      struct NCAL ncal;   
      memset(&ncal,0,sizeof(ncal));
      ArteTable<NCAL>::push_back(ncal); 
      unsigned int nncal = ArteTable<NCAL>::size();
      ArtePointer<NCAL> nd(nncal);
      createRelation(ns,nd,&NESL::ncal);
      if(ns->fpl == 0) ns->fpl = nncal;   
      ns->npl++;
      nd->cmp = ns->cmp;
      return nncal;
}

void  Geant2Arte::FillTree(char* name,int &nc)  {  
//  fill nlev and the volume tree into lvols,lcopy
    if(ivos == 0) { 
       arteMsg << "Geant2Arte::FillTree ivos =0 " << name; arteMsg.error();
    } 
    ncopy = nc;
    int indaut;
    crlvbk_(name,ncopy,indaut,nlev,lvols,lcopy);
    if(nlev < 0) {
       arteMsg << "crgede: nlev < 0 "; arteMsg.error();
    }
}

void  Geant2Arte::FillTree(const int nl , const char* lv,const int* lc)  {  
//  fill nlev and the volume tree into lvols,lcopy
    nlev = nl;
    if(nlev < 0) {
       arteMsg << "crgede: nlev < 0 "; arteMsg.error();
    }
    memcpy(lvols,lv,60);
    memcpy(lcopy,lc,60);
}

float  Geant2Arte::FillGvolParameter() {
//  get detector volume nr ivol 
    if(ivos == 0) { 
       arteMsg << "Geant2Arte::FillGvolParameter ivos = 0 " << name; 
       arteMsg.error();
    } 
    int jvos = *(gcbank_.lq + gclink_.jvolum -1 - ivos);
    //   check whether lvols is filled    
//  call the transformation routine and fill the geometric data in
    crvtrm_(nlev,lvols,lcopy,pos,rotm);
    int *pji = gcbank_.iq + jvos+1;
    float *pjx = (float*)pji;
    ishap = int (*pjx);
    pji = gcbank_.iq + jvos+3; 
    pjx = (float*)pji;
    int numed = int(*pjx);
    int* pjmd = gcbank_.lq + gclink_.jtmed -1 - numed;
    pji = gcbank_.iq + *pjmd + 5;
    pjx = (float*)pji;
    imat = int(*pjx);
    int* pjmt = gcbank_.lq + gclink_.jmate -1 - imat;
    pji = gcbank_.iq + *pjmt +8;
    xms = *pjx;
    return xms;
}

void Geant2Arte::FillNedeParameter(int & nn) {
    ArtePointer<NEDE> nd(nn);
    memcpy(&nd->xmin,&pos[0],24);
    memcpy(&nd->xmad,&pos[6],12);
    memcpy(&nd->cos,&pos[9] ,8);
    memcpy(&nd->rot,rotm    ,36);
    nd->shp = ishap;
    createRelation(ArtePointer<GMAT>(imat), nd,&GMAT::nede);
    float xm = (pos[5]-pos[4])/xms;
    nd->ms = xm*pow(0.0136*(1.+ 0.038*log(double(xm))),2.);
    strncpy(nd->gvol,name,4);
}

void Geant2Arte::FillNwalParameter(int & nn) {
    ArtePointer<NWAL> nd(nn);
    memcpy(&nd->xmin,&pos[0],24);
    memcpy(&nd->xmad,&pos[6],12);
    memcpy(&nd->rot,rotm    ,36);
    nd->shp = ishap;
    createRelation(ArtePointer<GMAT>(imat), nd,&GMAT::nwal);
    float xm =0;
    if(ishap != 9) xm = (pos[5]-pos[4])/xms;
    else           xm = (pos[1]-pos[0])/xms;
    nd->ms = xm*pow(0.0136*(1.+ 0.038*log(double(xm))),2.);
    nd->nsl =1;
    strncpy(nd->gvol,name,4);
}


void Geant2Arte::FillNcalParameter(int & nn) {
    ArtePointer<NCAL> nd(nn);
    memcpy(&nd->xmin,&pos[0],24);
    memcpy(&nd->xmad,&pos[6],12);
    createRelation(ArtePointer<GMAT>(imat), nd,&GMAT::ncal);
    float xm =0;
    if(ishap != 9) xm = (pos[5]-pos[4])/xms;
    else           xm = (pos[1]-pos[0])/xms;
    nd->ms = xm*pow(0.0136*(1.+ 0.038*log(double(xm))),2.);
    nd->ncl = 1; 
    strncpy(nd->gvol,name,4);
}

int  Geant2Arte::Get_Daughter_jin(char* moth,int * user,int nl) { 
    char mot[4], dau[4]; 
    strncpy(mot,&moth[4*nl-8],4); 
    strncpy(dau,&moth[4*nl-4],4);
    int ivolmoth = GetGvolNumber(mot);
    if(!ivolmoth)   { 
       arteMsg << "Gean2Arte - mother name";
       arteMsg.error();
    }
    int ivoldau  = GetGvolNumber(dau);
    if(!ivoldau)   { 
      arteMsg << "Gean2Arte - daughter name" << dau ;
       arteMsg.error();
    }
    int jvos = *(gcbank_.lq + gclink_.jvolum -1 - ivolmoth);
    int *pji = gcbank_.iq + jvos + 2;
    float *pjx = (float*)pji; 
    int ndau = int(*pjx);
    int idau  = user[nl-1];
    
    for (int i = 0; i<ndau; i++){
      int jin = *(gcbank_.lq + jvos -2 -i);
      pji = gcbank_.iq + jin + 1;
      float *pjx = (float*)pji;      
      if(int(*pjx) == ivoldau) {
	pji = gcbank_.iq + jin + 2;
        float *pjx = (float*)pji;  
	if(int(*pjx) == idau ) return jin;
      }	    
    }
    return 0;
}
void Geant2Arte::GetModule(int & ipl, char nvols[], int ncopy[]) {
   ArtePointer<NEDE> nd(ipl); 
   int copy = nd->gcop & 65535;
   int module =  nd->gcop >> 16;

   int nlev =0;
   ArtePointer<NESL> ns = nd->nesl;
   strncpy(&nvols[4*nlev],ns->name,4);
   ncopy[nlev] = ns.index();
   if(!ncopy[0])   { 
      arteMsg << "Gean2Arte - mother name";
      arteMsg.error();
   }

   for (;;) {
      int jvos = *(gcbank_.lq+gclink_.jvolum-1-GetGvolNumber(&nvols[4*nlev]));
      int *pji = gcbank_.iq + jvos + 2;
      float *pjx = (float*)pji; 
      int ndau = int(*pjx);
      for (int i = 0; i<ndau; i++){
         int jin = *(gcbank_.lq + jvos -2 -i);
         pji = gcbank_.iq + jin + 2;
         float *pjx = (float*)pji;
         int imodule = int(*pjx);
         int usm = imodule & 65535; 
         if(module != 0) {
            if(usm != module) continue;
         }
         else if(usm != copy) continue;

         nlev++;
         pji = gcbank_.iq + jin + 1;
         pjx = (float*)pji;  
         memcpy(&nvols[4*nlev], gcbank_.iq+gclink_.jvolum - 1 + int(*pjx),4);
         ncopy[nlev] = imodule;   
         if(module !=0)  module =0;
         else copy =0;
         break;
      }
      if(copy == 0) break; 
   }
}



