      SUBROUTINE  WTLGEO

************************************************************************
*
* WTLGEO
* written by Siegmund Nowak 12/92
*
* This routines defines TRACKER GEOMETRY (Aachen honeycomb tubes)
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* ISL        in           WT superlayer number
*
************************************************************************

      IMPLICIT NONE
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGBPIP.fi"
#include "gean/ZGOTR.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

      INTEGER IFIRST,IRHC,ISL,NSL,ISEC,ITYP,IMF,IVOLS(11)
      INTEGER MEDNUM,IUCOMP
      REAL PAR(8),ZP,ZPP(5),COSANG,SINANG,TANANG
      CHARACTER*4  SHAP, SLNAM

      SAVE IFIRST
      DATA IFIRST/0/

#include "arte/Arte.ff"
#include "auto/GEO.ff"

C--          DEFINE VOLUMINA FOR CHAMBERS AT FIRST ENTRY

      IF(IFIRST.EQ.0) THEN
         CALL WTLDAT('OTR/otr.dat')
         CALL WTLMED
         SHAP = 'PARA'

C        Rohacel wand (for the moment rohacel is replaced by mylar)
         CALL GSVOLU( 'WTWA','BOX ',MEDNUM(1,'MYLAR'),PAR,0,IVOLS(10))
         CALL GSVOLU( 'WTWM','BOX ',MEDNUM(2,'MYLAR'),PAR,0,IVOLS(11))

c--1     10 mm single layer sensitive
         CALL UCTOH('WTL1',WTDT(1),4,4)
         CALL GSVOLU(WTDT(1),SHAP,MEDNUM(3,'OTR_WS10'),PAR,0,IVOLS(1))

c--2     5 mm single layer sensitive
         CALL UCTOH('WTL2',WTDT(2),4,4)
         CALL GSVOLU(WTDT(2),SHAP,MEDNUM(3,'OTR_WS5'),PAR,0,IVOLS(2))

c--3     5 mm single layer nonsensitive
         CALL UCTOH('WTL3',WTDT(3),4,4)
         CALL GSVOLU(WTDT(3),SHAP,MEDNUM(1,'OTR_WS5'),PAR,0,IVOLS(3))

c--4     10 mm double layer sensitive
         CALL UCTOH('WTL4',WTDT(4),4,4)
         CALL GSVOLU(WTDT(4),SHAP,MEDNUM(3,'OTR_WD10'),PAR,0,IVOLS(4))

c--5     5 mm  double layer sensitive
         CALL UCTOH('WTL5',WTDT(5),4,4)
         CALL GSVOLU(WTDT(5),SHAP,MEDNUM(3,'OTR_WD5'),PAR,0,IVOLS(5))

c--6     5 mm double layer nonsensitive
         CALL UCTOH('WTL6',WTDT(6),4,4)
         CALL GSVOLU(WTDT(6),SHAP,MEDNUM(1,'OTR_WD5'),PAR,0,IVOLS(6))

c--7     10 mm single layer sensitive in magnetic field
         CALL UCTOH('WTL7',WTDT(7),4,4)
         CALL GSVOLU(WTDT(7),SHAP,MEDNUM(4,'OTR_WS10'),PAR,0,IVOLS(7))

c--8     5 mm single layer sensitive in magnetic field
         CALL UCTOH('WTL8',WTDT(8),4,4)
         CALL GSVOLU(WTDT(8),SHAP,MEDNUM(4,'OTR_WS5'),PAR,0,IVOLS(8))

c--9     5 mm single layer nonsensitive in magnetic field
         CALL UCTOH('WTL9',WTDT(9),4,4)
         CALL GSVOLU(WTDT(9),SHAP,MEDNUM(2,'OTR_WS5'),PAR,0,IVOLS(9) )

         COSANG = COS(ANGWT * 0.01745329)
         SINANG = SIN(ANGWT * 0.01745329)
         TANANG = SINANG/COSANG

         IFIRST = 1
      ENDIF

      ISL = CURRSL
      CALL UHTOC(HNESL_NAME(ISL),4,SLNAM,4)
      IF(INESL_LAY(ISL).EQ.0) THEN
         C78 = 'WTL-SUPERLAYER '//SLNAM//' NOT ACTIVATED'
         CALL ME78WA
         GO TO 99
      ENDIF


C--   define the superlayer volumina and position
      IMF = INESL_MFL(ISL)
      IF(IMF.EQ.0) THEN
         CALL CGGESL(SLNAM,'MOTH',0)
      ELSE
         CALL CGGESL(SLNAM,'MAGN',0)
      ENDIF
      CALL GSATT(SLNAM,'COLO',-5)
      IF(IDEBUG.NE.0) WRITE(LPRNT,*) 'START ',SLNAM,' ',
     +                                 FNESL_Z1(ISL),FNESL_Z2(ISL)
C
      NSL = IUCOMP(SLNAM,DEWT,NSLWT)
      IF(NSL.EQ.0) CALL MEERRO('WTLGEO: '//SLNAM//' not found in DEWT')

      CALL WTLPOS(NSL)

      ZPP(1) = -0.5*(FNESL_Z2(ISL)-FNESL_Z1(ISL))

C     above the microstrips

c     dummy tubes

      ISEC = 13
      IRHC = 1
      ZP = ZPP(1)
      ITYP = 6*IMF + 3
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)
      ZPP(2) = ZP

c     real tubes

      ISEC = 1
      ZP = ZPP(2)
      IRHC = -1
      ITYP = 6*IMF + 2
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)
      ZPP(3) = ZP + DLOVWT

C     below  the microstrips

c     real tubes

      ISEC = 2
      IRHC = 1
      ZP = ZPP(1)
      ITYP = 6*IMF + 2
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

c     dummy tubes

      ISEC = 14
      ZP = ZPP(2)
      IRHC = -1
      ITYP = 6*IMF + 3
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

C     tube divided in four pieces  inner part  right hand side

C     real tubes  (upper part)
      ISEC = 3
      IRHC = 1
      ZP = ZPP(1)
      ITYP = 6*IMF + 2
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

C     dummy  tubes
      ISEC = 15
      IRHC = -1
      ZP = ZPP(2)
      ITYP = 6*IMF + 3
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

c     dummy tubes (lower part)

      ISEC = 16
      IRHC = 1
      ZP = ZPP(1)
      ITYP = 6*IMF + 3
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

C     real tubes

      ISEC = 4
      IRHC = -1
      ZP = ZPP(2)
      ITYP = 6*IMF + 2
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

C     tube divided in four pieces   inner part   left hand side

C     real tubes (upper part)

      ISEC = 5
      IRHC = 1
      ZP = ZPP(1)
      ITYP = 6*IMF + 2
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

C     dummy  tubes

      ISEC = 17
      IRHC = -1
      ZP = ZPP(2)
      ITYP = 6*IMF + 3
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

c     dummy tubes (lower part)

      ISEC = 18
      IRHC = 1
      ZP = ZPP(1)
      ITYP = 6*IMF + 3
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

c     real tubes

      ISEC = 6
      IRHC = -1
      ZP = ZPP(2)
      ITYP = 6*IMF + 2
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

C     medium part (tube type 1 divided in the middle) right hand side

      ISEC = 7
      IRHC = 0
      ZP = ZPP(3)
      ITYP = 6*IMF + 1
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

      ISEC = 8
      ZP = ZPP(3)
      ITYP = 6*IMF + 1
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

C     medium part (tube type 1 divided in the middle) left hand side

      ISEC = 9
      ZP = ZPP(3)
      ITYP = 6*IMF + 1
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

      ISEC = 10
      ZP = ZPP(3)
      ITYP = 6*IMF + 1
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

C     outer part (TUBE type 1 without division) right hand side

      ISEC = 11
      ZP = ZPP(3)
      ITYP = 6*IMF + 1
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)

C     outer part (TUBE type 1 without division) left hand side

      ISEC = 12
      ZP = ZPP(3)
      ITYP = 6*IMF + 1
      CALL WTLSTR(ISL,ISEC,ZP,ITYP,IVOLS,IRHC)
      ZPP(5) = ZP

   99 RETURN
      END
