
      SUBROUTINE WTLPOS(ISL)

************************************************************************
*
* WTLPOS
* written by Siegmund Nowak, 21/11/94 19.25.08
*
* This routines defines more precisely the boundaries for honeycomb chambers
*
*     called from WTLGEO
*
* Arguments  kind         description
*-----------------------------------------------------------------------
* ISL        in           superlayer number
************************************************************************

      IMPLICIT NONE

#include "gean/ZGOTR.fi"

      INTEGER ISL,I,IFIRST
      REAL XMIN,XMAX,XNL,BREIT,COSANG
      SAVE IFIRST

      IF(IFIRST.EQ.0) THEN
         COSANG = COS(ANGWT * 0.01745329)
         IFIRST = 1
      ENDIF

      XMIN = XIWT(ISL)
      XNL = NWIRWT(ISL,3) + .16667
      BREIT = XNL * PITWT(2)
      DO I=1,2
      XLWT(ISL,3,I) = XMIN
      XLWT(ISL,4,I) = XMIN
      XLWT(ISL,15,I) = XMIN
      XLWT(ISL,16,I) = XMIN
      XRWT(ISL,5,I) = -XMIN
      XRWT(ISL,6,I) = -XMIN
      XRWT(ISL,17,I) = -XMIN
      XRWT(ISL,18,I) = -XMIN
      IF(I.EQ.1) THEN
         XMAX = XMIN + BREIT
      ELSE
         XMAX = XMIN + BREIT/COSANG
      ENDIF
      XRWT(ISL,3,I) = XMAX
      XRWT(ISL,4,I) = XMAX
      XRWT(ISL,15,I) = XMAX
      XRWT(ISL,16,I) = XMAX
      XLWT(ISL,5,I) = -XMAX
      XLWT(ISL,6,I) = -XMAX
      XLWT(ISL,17,I) = -XMAX
      XLWT(ISL,18,I) = -XMAX
      ENDDO

      XNL = NWIRWT(ISL,1) - .333333
      BREIT = XNL * PITWT(2)
      DO I=1,2
      XLWT(ISL,1,I) = -0.5 * BREIT
      XRWT(ISL,1,I) = - XLWT(ISL,1,I)
      XLWT(ISL,2,I) = XLWT(ISL,1,I)
      XRWT(ISL,2,I) = XRWT(ISL,1,I)
      XLWT(ISL,13,I) = XLWT(ISL,1,I)
      XRWT(ISL,13,I) = XRWT(ISL,1,I)
      XLWT(ISL,14,I) = XLWT(ISL,1,I)
      XRWT(ISL,14,I) = XRWT(ISL,1,I)
      BREIT = BREIT/COSANG
      ENDDO

      XLWT(ISL,7,1) = XRWT(ISL,3,1) -.33333*(PITWT(2) + PITWT(1))
      XLWT(ISL,7,2) = XRWT(ISL,3,2) -.33333*(PITWT(2) + PITWT(1))/COSANG
      DO I=1,2
      XLWT(ISL,8,I) = XLWT(ISL,7,I)
      XRWT(ISL,9,I) = - XLWT(ISL,7,I)
      XRWT(ISL,10,I)= XRWT(ISL,9,I)
      ENDDO

      XNL = NWIRWT(ISL,7) + .16667
      BREIT = XNL * PITWT(1)
      DO I=1,2
      XRWT(ISL,7,I) = XLWT(ISL,7,I) + BREIT
      XRWT(ISL,8,I) = XRWT(ISL,7,I)
      XLWT(ISL,9,I) = - XRWT(ISL,7,I)
      XLWT(ISL,10,I) = XLWT(ISL,9,I)
      BREIT = BREIT/COSANG
      ENDDO

      XLWT(ISL,11,1) = XRWT(ISL,7,1) - .66667*PITWT(1)
      XLWT(ISL,11,2) = XRWT(ISL,7,2) - .66667*PITWT(1)/COSANG
      XRWT(ISL,12,1) = -XLWT(ISL,11,1)
      XRWT(ISL,12,2) = -XLWT(ISL,11,2)

      XNL = NWIRWT(ISL,11) + .16667
      BREIT = XNL * PITWT(1)
      XRWT(ISL,11,1) = XLWT(ISL,11,1) + BREIT
      XLWT(ISL,12,1) = - XRWT(ISL,11,1)
      XRWT(ISL,11,2) = XLWT(ISL,11,2) + BREIT/COSANG
      XLWT(ISL,12,2) = - XRWT(ISL,11,2)

      RETURN
      END

