*CMZ :          04/09/96  20.27.53  by  Fedor Ratnikov
*CMZ :  1.01/02 05/02/96  23.53.41  by  Fedor Ratnikov
*-- Author :    Fedor Ratnikov   05/02/96
************************************************************************
*
* L1MUOPO
* written by Fedor Ratnikov, 05/02/96 22.03.15
*
* This routines action:
* returns the number and position of the most reasonable track for
* muon pretrigger.
*
*----------------------------------------------------------------------*
* MePo        in           Message pointer
* itrk        out          closest track (0 if none)
* x,y,z       out          MC coordinates in MU3
************************************************************************
c
      SUBROUTINE L1MUOPO(MePo,itrk,x,y,z)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1clink.fi"
#include "l1si/rcfdef.fi"
#include "l1si/ydef.fi"
#include "l1si/l1banks.fi"
#include "arte/Arte.fi"
c
      INTEGER MePo,itrk
      REAL x,y,z
c
      INTEGER NtrkMAX
      PARAMETER (NtrkMAX=100)
      INTEGER isl,itype,Ntrk3,Ntrk4,iTraHit,j3,j4,
     &     MuPlaFirst,MuPlaLast,MxPlaFirst,MxPlaLast,
     &     Itrs3(NtrkMAX),Itrs4(NtrkMAX),imimp,ipla,
     &     itra,iver,itraparent,itypeparent,idGEANT
      CHARACTER*4 cName1,cName2
      LOGICAL inited
      DATA inited /.FALSE./
c
#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
#include "l1si/ydef.ff"
#include "l1si/l1mesdf.ff"
c
      IF(.NOT.inited)   THEN   ! initialisation
       DO isl=1,N_U(JGESL) ! loop over SL
        itype = I_V(JGESL_CMP,isl,JGESL) ! type of detector
        IF(itype.EQ.LGESL_MUO.AND.
     &       IGESL_NSL(isl).EQ.3)   THEN           !  is MU3
         MuPlaFirst = I_V(JGESL_FPL,isl,JGESL)
         MuPlaLast = MuPlaFirst+I_V(JGESL_NPL,isl,JGESL)-1
        ELSEIF(itype.EQ.LGESL_MUX.AND.
     &       IGESL_NSL(isl).EQ.3)   THEN           !  is MX3
         MxPlaFirst = I_V(JGESL_FPL,isl,JGESL)
         MxPlaLast = MuPlaFirst+I_V(JGESL_NPL,isl,JGESL)-1
        ENDIF
       ENDDO
      ENDIF
c
      Ntrk3 = NtrkMAX
      Ntrk4 = NtrkMAX
      iTraHit = 0
      itrk = 0
      z = 0.
c      hits in MU3&MU4
      CALL L1GETR0(L1MEstor(MePo+L1MEpoint(0)+L1POtrk0),Ntrk4,Itrs4)
      CALL L1GETR0(L1MEstor(MePo+L1MEpoint(1)+L1POtrk0),Ntrk3,Itrs3)
      DO j4=1,Ntrk4
       DO j3=1,Ntrk3
        IF(Itrs3(j3).EQ.Itrs4(j4).AND.     ! track hits both
     &       (iTraHit.EQ.0.OR.Itrs3(j3).LT.iTraHit))  THEN ! closest
         iTraHit = Itrs3(j3)
        ENDIF
       ENDDO
      ENDDO
      IF(iTraHit.EQ.0)    GOTO 999  ! nothing found
c        looking for point
      DO imimp=1,NMIMP()
       IF(OMIMP_MTRA(imimp).EQ.iTraHit)  THEN  ! this track
        ipla = IMIMP_GEDE(imimp)
        IF((MuPlaFirst.LE.ipla.AND.ipla.LE.MuPlaLast).OR.
     &      (MxPlaFirst.LE.ipla.AND.ipla.LE.MxPlaLast))  THEN ! MU3
         x = FMIMP_X(imimp)
         y = FMIMP_Y(imimp)
         z = FMIMP_Z(imimp)
         GOTO 100
        ENDIF
       ENDIF
      ENDDO
 100  CONTINUE
      IF (L1PARprnlev.gt.1 )   THEN
       WRITE( L1LUNprn,900) iTraHit,x,y,z
c
       itra = iTraHit
 300   CONTINUE
       iver = IMTRA_ORIG(itra)
       itype = OMTRA_TOPP(itra)
       IF(iver.GT.0)  THEN
        itraparent = OMVER_BTRA(iver)
       ELSEIF(iver.LT.0)  THEN
        itraparent = -iver      ! not vertex but resonance
        iver = 0
       ELSE                     ! iver=0
       ENDIF
       IF(itraparent.GT.0)    THEN
        itypeparent = OMTRA_TOPP(itraparent)
       ELSE
        itypeparent = 0
       ENDIF
       CALL L1CPART(itype,idGEANT,cName1)
       CALL L1CPART(itypeparent,idGEANT,cName2)
       IF(iver.GT.0)  THEN
        WRITE(L1LUNprn,901) cName1,itra,cName2,
     &       FMVER_X(iver),FMVER_Y(iver),FMVER_Z(iver),
     &       FMTRA_PX(itra),FMTRA_PZ(itra),FMTRA_PZ(itra)
       ELSE
        WRITE(L1LUNprn,902) cName1,itra,cName2,
     &       FMTRA_PX(itra),FMTRA_PZ(itra),FMTRA_PZ(itra)
       ENDIF
       IF(itraparent.GT.0)  THEN
        itra = itraparent
        GOTO 300
       ENDIF
      ENDIF
      itrk = iTraHit
 999  CONTINUE
      RETURN

 900  FORMAT(1x,'L1MUOPO==> it,x,y,z:',i4,3f8.2)
 901  FORMAT(1x,'L1MUOPO==>',A4,'(',I4,')',' originates from ',A4,
     &     ' @xyz:',3f6.1,' with Pxyz:',3f5.1)
 902  FORMAT(1x,'L1ECAPO==>',A4,'(',I4,')',' originates from ',A4,
     &     ' @xyz:',18X,' with Pxyz:',3f5.1)
      END

