*CMZ :  1.00/00 07/02/95  20.03.51  by  Dominik Ressing
*-- Author :    Dominik Ressing   27/01/95
************************************************************************
*
* L1PRCVE
* written by Dominik Ressing, 27/01/95 14.18.48
*
* This routines action:
* Verify PRC data structure:
* iFlag = 1: check weather all FIFO are empty!
* iFlag = 2: clera all FIFO and timing information!
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* iFlag       in          what is to verify
* iErr        out         set to non-zero on error
*
************************************************************************
c
      SUBROUTINE L1PRCVE(iFlag,iErr)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1prcdf.fi"
c
      INTEGER nPrc,iPc,iPcPo
      INTEGER iFlag,iErr
#include "l1si/l1prcdf.ff"
c
c
      nPrc = L1PARnpre+L1PARntfu+L1PARntpm+L1PARnmcu
      iPcPo = 1
      DO iPc = 1,nPrc
         IF ( iFlag.eq.1 .and. L1PCstor(iPcPo+L1PCnfif).ne.0 ) THEN
            iErr = 2
            WRITE (L1LUNprn,900) iPc,L1PCstor(iPcPo+L1PCtype),
     &           L1PCstor(iPcPo+L1PCnfif)
            L1PCstor(iPcPo+L1PCnfif) = 0
         END IF
         IF ( iFlag.eq.2 ) THEN
            L1PCstor(iPcPo+L1PCnfif) = 0
            L1PCstor(iPcPo+L1PCbusy) = 0
            L1PCstor(iPcPo+L1PClast) = 0
         END IF
         IF ( iPc.le.L1PARnpre ) THEN
            IF ( L1PCstor(iPcPo+L1PCtype).ne.L1PCtpre ) THEN
               WRITE (L1LUNprn,901) iPc,L1PCstor(iPcPo+L1PCtype),
     &           L1PCstor(iPcPo+L1PCnum),L1PCtpre
               L1PCstor(iPcPo+L1PCtype) = L1PCtpre
               iErr = 2
            END IF
         ELSE IF ( iPc.le.L1PARnpre+L1PARntfu ) THEN
            IF ( L1PCstor(iPcPo+L1PCtype).ne.L1PCttfu ) THEN
               WRITE (L1LUNprn,901) iPc,L1PCstor(iPcPo+L1PCtype),
     &           L1PCstor(iPcPo+L1PCnum),L1PCttfu
               L1PCstor(iPcPo+L1PCtype) = L1PCttfu
               iErr = 2
            END IF
         ELSE IF ( iPc.le.L1PARnpre+L1PARntfu+L1PARntpm ) THEN
            IF ( L1PCstor(iPcPo+L1PCtype).ne.L1PCttpm ) THEN
               WRITE (L1LUNprn,901) iPc,L1PCstor(iPcPo+L1PCtype),
     &           L1PCstor(iPcPo+L1PCnum),L1PCttpm
               L1PCstor(iPcPo+L1PCtype) = L1PCttpm
               iErr = 2
            END IF
         ELSE
            IF ( L1PCstor(iPcPo+L1PCtype).ne.L1PCtmcu ) THEN
               WRITE (L1LUNprn,901) iPc,L1PCstor(iPcPo+L1PCtype),
     &           L1PCstor(iPcPo+L1PCnum),L1PCtmcu
               L1PCstor(iPcPo+L1PCtype) = L1PCtmcu
               iErr = 2
            END IF
         END IF
        iPcPo = iPcPo + L1PClen
      END DO
c
 900  FORMAT(1x,'L1PRCVE==> invalid FIFO count in Processor ',
     &     I3,' type ',I2,' count:',I5)
 901  FORMAT(1x,'L1PRCVE==> invalid type in Processor ',
     &     I3,' type ',I2,' number:',I5,' should:',I3)
c
      RETURN
c
      END
