*CMZ :  1.00/01 21/03/95  15.45.08  by  Alexander Snizhko
*CMZ :  1.00/00 06/02/95  15.52.30  by  Dominik Ressing
*CMZ :  0.01/02 08/09/94  20.09.46  by  Fedor Ratnikov
*-- Author :    Dominik Ressing   13/08/94
************************************************************************
*
* L1TFUIN
* written by Dominik Ressing, 13/08/94 22.27.34
*
* This routines action:
* initializes the TFU wire connections. This routine must be preceeded
* by a call to L1DEFPC.
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* ierr       out          error flag: set to <>0 on error
*
************************************************************************
c
      SUBROUTINE L1TFUIN(ierr)
c
      IMPLICIT NONE
c
#include "gean/gcbank.fi"
#include "l1si/l1runpa.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1param.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1prcdf.fi"
c
      INTEGER ierr,iTFUpc,iTFU,iSEQdets(L1DETmaxseq),nSEQdet,
     &        iDet,i,kk,nCon,iLay,k,iConTFUcon,iSEQdet,iPoO,idu,
     &        jDet,maxtfu,iConTFU,iCon,iDetInf(L1DETINFlen,3),j,iPo,
     &        iDetSpe(L1DETSPElen,3),jSec,iSec,NextFree,nSec,
     &        ifi,ila,ifio,ilao,iPoWi(3),iWrTFU(3,L1DEFmaxtfu),
     &        layerC,ka,ke,iCoPo,NNa,NNe,iWM,iWrOr,iWrSi,iSup,
     &        jDetGeo,jCellGeo,jDetInf
      REAL    rDetGeo(L1GEOINFlen,3),
     &        rConWei,rConOrd,rWeiNor,P(L1POINTlen,3),r,x0,xE,xS,
     &        zDef,zMin,zMax
      LOGICAL Above,NOmix
c
      PARAMETER(maxtfu=15)
      DIMENSION iConTFU(maxtfu),rConWei(maxtfu),rConOrd(maxtfu),
     &          layerC(3,maxtfu),iConTFUcon(maxtfu)
#include "l1si/l1prcdf.ff"
c
      CALL VZERO(L1DETCONdetpo,L1DEFtfusecs*L1DEFmaxtfu)
      CALL VZERO(T1DETzSup,L1DETmaxsup)
      CALL VZERO(iSEQdets,L1DETmaxseq)
c
      nSEQdet = 0
      NextFree = 1
c
c     get numbers of required detectors
c
      DO iTFUpc = 1,L1PARntfu                       ! loop over all TFUs
         iTFU = L1PCstor(L1PCtfup(iTFUpc)+L1PCnum)  ! get TFU num
         iDet = L1DEFtfudef(L1TFUdetsl,iTFU)        ! sequential det num of TFU
         iSup = L1DEFtfudef(L1TFUsup,iTFU)          ! super layer number of TFU
         T1DETzSup(iSup) =  1000000.                ! reset minimal z of SL
         iWrTFU(1,iTFU) = 1                         ! first wire to TFU
         iWrTFU(2,iTFU) = 1
         iWrTFU(3,iTFU) = 1
         IF(L1PARprnlev.eq.8)
     &        WRITE(L1LUNprn,800) iTFU,iDet
 800     FORMAT(1x,'TFU',i3.3,
     &        ' is connected to sequential detector ',i4)
         DO i = 1,nSEQdet                           ! detector allready stored ??
            IF ( iSEQdets(i).eq.iDet ) iDet = 0         ! dont store again
         END DO
         IF ( iDet.ne.0 ) THEN                      ! store ??
            IF (nSEQdet.ge.L1DETmaxseq) THEN       ! watch array bounds !!
               WRITE (L1LUNprn,*)
     &         'L1TFUIN ==> sequential detector number exceeded',
     &          nSEQdet
               ierr = 1
               RETURN
            END IF
            nSEQdet = nSEQdet + 1                   ! store !!
            iSEQdets(nSEQdet) = iDet
         END IF
      END DO
c
c     Loop for all detectors over all their sections.
c          Loop for each section over all TFUs and collect the numbers and weights
c          for the connected TFUs
c
c
      DO iSEQdet = 1,nSEQdet
      jDET = iSEQdets(iSEQdet)
      iDetSpe(L1DETSPEdet,1) = jDet                   !
      iDetSpe(L1DETSPEsection,1) = 1
      iDetSpe(L1DETSPElayer,1) = 1
      CALL l1detif(iDetSpe,jDetGeo,jDetInf,jCellGeo)  ! obtain detector information
      IF ( jDetGeo.le.0 ) THEN  ! valid detector ??
         WRITE (L1LUNprn,*)
     &        'L1TFUIN ==> invalid detctor connected ',
     &        jDet,1,1
         ierr = 1
         RETURN
      END IF
      nSec = IQ(jDetInf+L1DETINFnsec)
      DO jSec = 1,nSec                                ! loop over all sections of det.
         nCon = 0                                     ! no connected TFU found so far
         rWeiNor = 0.
         DO iTFUpc = 1,L1PARntfu                      ! loop over all TFUs
            iTFU = L1PCstor(L1PCtfup(iTFUpc)+L1PCnum) ! get TFU num
            iDet = L1DEFtfudef(L1TFUdetsl,iTFU)       ! connected detector
            IF ( iDet.eq.jDet ) THEN                  ! match ?? -> compare section
               iPo = L1TFUfsec
            DO i=1,L1DEFtfudef(L1TFUnsec,iTFU)        ! loop over all sections for TFU
               iSec = L1DEFtfudef(iPo+L1TFUsec,iTFU)  ! section of this connection
               IF (iSec.eq.jSec) THEN                 ! match? -> store
                  IF ( nCon.eq.maxtfu ) THEN          ! watch array bounds !!
                     WRITE (L1LUNprn,*)
     &               'L1TFUIN ==> TFUs/section  exceeded',nCon
                     ierr = 1
                     RETURN
                  END IF
                  nCon = nCon + 1                             ! store connection Info
                  iConTFU(nCon) = iTFU
                  iConTFUcon(nCon) = i
                  rConWei(nCon) = T1DEFtfudef(iPo+L1TFUweight,iTFU) ! region weight
                  rConOrd(nCon) = T1DEFtfudef(iPo+L1TFUored,iTFU)   ! ORed weight
                  layerC(L1DETCONposZ,nCon) =
     &                 L1DEFtfudef(L1TFUlaz,iTFU)                   ! axial layer
                  layerC(L1DETCONposN,nCon) =
     &                 L1DEFtfudef(L1TFUlan,iTFU)                   ! - alpha layer
                  layerC(L1DETCONposP,nCon) =
     &                 L1DEFtfudef(L1TFUlap,iTFU)                   ! + alpha layer
                  rWeiNor = rWeiNor + rConWei(nCon)                 ! region weight norm
               END IF
               iPo = iPo + L1TFUseclen
            END DO
            END IF
         END DO
c
c     now we do have all weights for all TFUs of this section
c
         IF ( nCon.gt.0 ) THEN                         ! any connected TFU ??
            iPo = NextFree                             ! get storage pointer
            NextFree = NextFree + L1DETCONheadlen
            IF ( NextFree.ge.L1DETCONsize ) THEN       ! watch storage overflow
               WRITE (L1LUNprn,*)
     &          'L1TFUIN ==> connections storage exceeded',NextFree
               ierr = 1
               RETURN
            END IF
            L1DETCONstor(iPo+L1DETCONncon) = nCon      ! save number of Connections
c
            NNa = 1                                    ! 3 layers for wire detector
            NNe = 3                                    ! 3 layers for wire detector
            KK = 1                                     ! 1 row
            IF ( IQ(jDetInf+L1DETINFwirepad).gt.1 ) THEN   ! PAD-like ?
               NNa = L1DETCONposZ                         ! only one layer
               NNe = L1DETCONposZ                         ! only one layer
               KK = IQ(jDetInf+L1DETINFnCol)              ! KK rows
            END IF
c           --- set z ranges to invalid
            zDef = -1.
            zMin = 99999999.
            zMax = -1.
c
            DO i=NNa,NNe                               ! loop over layers
               iDetSpe(L1DETSPEdet,i) = jDet
               iDetSpe(L1DETSPEsection,i) = jSec
               iDetSpe(L1DETSPElayer,i) = layerC(i,1)  ! all layers are like con 1
               CALL l1detif(iDetSpe(1,i),jDetGeo,
     &                      jDetInf,jCellGeo)
               IF ( jDetGeo.le.0 ) THEN ! valid detector ??
                  WRITE (L1LUNprn,*)
     &                 'L1TFUIN ==> invalid detctor connected ',
     &                 jDet,layerC(i,1),jSec
                  ierr = 1
                  RETURN
               END IF
               CALL UCOPY(Q(jDetGeo+1),rDetGeo(1,i),L1GEOINFlen)
               CALL UCOPY(IQ(jDetInf+1),iDetInf(1,i),L1DETINFlen)
c              --- find min and max z
               zMin = min(zMin,rDetGeo(L1GEOINFz,i))
               zMax = max(zMax,rDetGeo(L1GEOINFz,i))
c              --- check for stereo angles
               IF ( i.eq.L1DETCONposZ ) THEN
                  zDef = rDetGeo(L1GEOINFz,i)
                  IF ( rDetGeo(L1GEOINFsin_al,i).ne.0. ) GO TO 1001
               ELSE IF ( i.eq.L1DETCONposP ) THEN
                  IF ( rDetGeo(L1GEOINFsin_al,i).le.0. ) GO TO 1001
               ELSE IF ( i.eq.L1DETCONposN ) THEN
                  IF ( rDetGeo(L1GEOINFsin_al,i).ge.0. ) GO TO 1001
               END IF
            END DO
c           --- z parameter set ??
            IF ( zDef.lt.0. .or. zMax.lt.0. .or. zMIN.gt.zMax ) THEN
               WRITE (L1LUNprn,*)
     &              'L1TFUIN ==> invalid detector/layers assignment:',
     &              jDet,jSec,(layerC(k,1),k=NNa,NNe)
               ierr = 1
               RETURN
            END IF
c           --- detector below or above x=0. ??
            IF (rDetGeo(L1GEOINFx0,L1DETCONposZ).ge.0. ) THEN
               Above = .true.
               NOmix = .false.
            ELSE IF ((rDetGeo(L1GEOINFx0,L1DETCONposZ)+
     &                rDetGeo(L1GEOINFsx,L1DETCONposZ)).le.0. ) THEN
               Above = .false.
               NOmix = .false.
            ELSE
               Above = .true.
               NOmix = .true.
            END IF
c           --- make start point
            DO i=NNa,NNe                               ! loop over layers
               P(L1POINTdx,i) = 0.                     ! store start point of detector
               P(L1POINTdy,i) = 0.
               P(L1POINTy0,i) = rDetGeo(L1GEOINFy0,i)
               P(L1POINTz0,i) = rDetGeo(L1GEOINFz,i)
               IF ( Above ) THEN
                  P(L1POINTx0,i) = rDetGeo(L1GEOINFx0,i)
                  CALL l1pohit(iDetSpe(1,i),P(1,i),iPoWi(i),idu) !first Cell
               ELSE
                  P(L1POINTx0,i) = rDetGeo(L1GEOINFx0,i) +
     &                 rDetGeo(L1GEOINFsx,i)
                  CALL l1pohit(iDetSpe(1,i),P(1,i),idu,iPoWi(i)) !last Cell
               END IF
c
               IF ( iPoWi(i).le.0 ) THEN
                  WRITE (L1LUNprn,*)
     &                 'L1TFUIN ==> invalid first wire in range',
     $                 iPoWi(i),i
                  ierr = 1
                  RETURN
               END IF
c
c
            END DO
c           --- store connections
            DO iCon=1,nCon
               iPo = NextFree                          ! allocate storage
               NextFree = NextFree + L1DETCONcolen
               IF ( NextFree.ge.L1DETCONsize ) THEN
                  WRITE (L1LUNprn,*)
     &            'L1TFUIN ==> connections storage exceeded',NextFree
                  ierr = 1
                  RETURN
               END IF
               iTFU = iConTFU(iCon)                    ! build connection header
               iSup = L1DEFtfudef(L1TFUsup,iTFU)           ! super layer number of TFU
               iCoPo = iPo                                 ! pointer to header
               L1DETCONdetpo(iConTFUcon(iCon),iTFU) = iPo  ! save pointer
               L1DETCONstor(iPo+L1DETCONdet) = jDet        ! save detector/TFU info
               L1DETCONstor(iPo+L1DETCONsec) = jSec
               L1DETCONstor(iPo+L1DETCONtfu) = iTFU
               L1DETCONstor(iPo+L1DETCONnORed) = 0         ! no connected wire ranges
               L1DETCONstor(iPo+L1DETCONnsing) = 0
c
               IF ( iSup.ge.1 .and. iSup.le.L1DETmaxSup ) THEN
                  T1DETzSup(iSup) =                        ! store minimal z of SL
     &                 min(T1DETzSup(iSup),P(L1POINTz0,L1DETCONposZ))
               ELSE
                  WRITE (L1LUNprn,*)
     &                 'L1TFUIN ==> invalid Superlayer number',
     &                 iSup
                  ierr = 1
                  RETURN
               END IF
c
               r = rConWei(icon)/rWeiNor                   ! fraction of det covered
               x0 = P(L1POINTx0,L1DETCONposZ)              ! start value of x-range
               xS = rDetGeo(L1GEOINFsx,L1DETCONposZ)*r     ! covered size
               IF ( .not.Above ) THEN                      ! below x=0 ?
                  r  = -1.*r                                 ! reverse order
                  x0 = x0 - xS                               ! correct geo info
               END IF
               T1DETCONstor(iPo+L1DETCONx0) = x0   ! write start value
               T1DETCONstor(iPo+L1DETCONxs) = xS   ! write range
               T1DETCONstor(iPo+L1DETCONz0) = zDef ! write nominal z
               T1DETCONstor(iPo+L1DETCONzF) = zMin ! write minimal z
               T1DETCONstor(iPo+L1DETCONzL) = zMax ! write maximal z
c              --- search all layers for wire ranges
               DO iLay=NNa,NNe                             ! loop over layers
                  iWM = MOD(iLay-NNa,3)+1                  ! WM num allso for PAD like
                  P(L1POINTx0,iLay) = P(L1POINTx0,iLay) +  ! move point to end in x
     &                 r * rDetGeo(L1GEOINFsx,iLay)
                  CALL l1pohit(iDetSpe(1,iLay),P(1,iLay),idu,ke)! ke:last hit in x-range
                  ka = iPoWi(iLay)                        ! first hit
c
c
                  IF ( ke.le.0 ) THEN
                     WRITE (L1LUNprn,*)
     &                 'L1TFUIN ==> invalid wire in range',
     $                    ke,iLay
                     ierr = 1
                     RETURN
                  END IF
c
c
                  IF (rConOrd(iCon).eq.0.) THEN           ! only single wires
                     ifio = 0
                     ilao = 0
                     ifi  = min(ka,ke)
                     ila  = max(ka,ke)
                     iWrSi = iWrTFU(iWM,iTFU)             ! first input number of TFU WM
                     iWrTFU(iWM,iTFU) = iWrSi + ila-ifi+1 ! next TFU input # = last+1
                  ELSE IF (rConOrd(iCon).eq.1.) THEN       ! only ORed wires
                     ifio = min(ka,ke)
                     ilao = max(ka,ke)
                     iWrOr = iWrTFU(iWM,iTFU)             ! first input number of TFU WM
                     iWrTFU(iWM,iTFU)=iWrOr+(ilao-ifio+2)/2 ! next TFU input # = last+1
                     ifi  = 0
                     ila  = 0
                  ELSE
                         ! both kinds
                     IF (NOmix) THEN
                        WRITE (L1LUNprn,*)
     &                  'L1TFUIN ==> invalid ORed/single spec.',
     &                   iTFU,jDet,jSec
                     ELSE IF ( Above ) THEN                  ! detector above = 0. ?
                        ifi  = ka                            ! first single then ORed
                        ila  = ka - 1 +
     &                       INT(FLOAT(ke-ka+1)*(1.-rConOrd(iCon)))
                        ifio = ila + 1
                        ilao = ke
                        iWrSi = iWrTFU(iWM,iTFU)
                        iWrTFU(iWM,iTFU) = iWrSi + ila-ifi+1
                        iWrOr = iWrTFU(iWM,iTFU)
                        iWrTFU(iWM,iTFU)=iWrOr+(ilao-ifio+2)/2
                     ELSE                                    ! detector below =0.
                        ifio = ke                            ! first ORed then single
                        ilao = ke - 1 +
     &                       INT(FLOAT(ka-ke+1)*rConOrd(iCon))
                        ifi  = ilao + 1
                        ila  = ka
                        iWrOr = iWrTFU(iWM,iTFU)
                        iWrTFU(iWM,iTFU)=iWrOr+(ilao-ifio+2)/2
                        iWrSi = iWrTFU(iWM,iTFU)
                        iWrTFU(iWM,iTFU) = iWrSi + ila-ifi+1
                     END IF
                  END IF
                  DO k=1,KK                                ! for all columns
                     iWM = MOD(k,3) + iLay-NNa             ! WM num allso for PAD like
                     IF ( ila.gt.0 ) THEN                  ! any single wire ?
                        IF ( iWM.eq.1 ) THEN                   !
                           iPo = NextFree ! allocate storage
                           NextFree = NextFree + 3*L1DETCONrangelen
                           IF ( NextFree.ge.L1DETCONsize ) THEN
                            WRITE (L1LUNprn,*)
     &                     'L1TFUIN ==> connections storage exceeded',
     &                      NextFree
                            ierr = 1
                            RETURN
                           END IF
                           CALL VZERO(L1DETCONstor(iPo),
     &                          3*L1DETCONrangelen)
                        END IF
                        L1DETCONstor(iPo+L1DETCONwrTFU) = iWrSi
                        L1DETCONstor(iPo+L1DETCONlayer) =
     &                      layerC(iLay,iCon) ! save range
                        L1DETCONstor(iPo+L1DETCONfirst) = ifi
                        L1DETCONstor(iPo+L1DETCONlast)  = ila
                        L1DETCONstor(iCoPo+L1DETCONnsing)  =
     &                       L1DETCONstor(iCoPo+L1DETCONnsing) + 1
                        iPo = iPo + L1DETCONrangelen
                     END IF
                     IF ( ilao.gt.0 ) THEN                          ! any ORed wire ??
                        IF ( iWM.eq.1 ) THEN                   !
                           iPoO = NextFree                            ! allocate ...
                           NextFree = NextFree + 3*L1DETCONrangelen
                           IF ( NextFree.ge.L1DETCONsize ) THEN
                            WRITE (L1LUNprn,*)
     &                     'L1TFUIN ==> connections storage exceeded',
     &                      NextFree
                            ierr = 1
                            RETURN
                           END IF
                           CALL VZERO(L1DETCONstor(iPoO),
     &                          3*L1DETCONrangelen)
                        END IF
                        L1DETCONstor(iPoO+L1DETCONwrTFU) = iWrOr
                        L1DETCONstor(iPoO+L1DETCONlayer) =
     &                         layerC(iLay,iCon)   ! save range
                        L1DETCONstor(iPoO+L1DETCONfirst) = ifio
                        L1DETCONstor(iPoO+L1DETCONlast)  = ilao
                        L1DETCONstor(iCoPo+L1DETCONnORed)  =
     &                       L1DETCONstor(iCoPo+L1DETCONnORed) + 1
                        iPoO = iPoO + L1DETCONrangelen
                     END IF
c                    --- next column if pad-like
                     if(ilao.le.0) then
                        ifi  = ifi  + iDetInf(L1DETINFnRow,L1DETCONposZ)
                        ila  = ila  + iDetInf(L1DETINFnRow,L1DETCONposZ)
                     else
                        ifio = ifio + iDetInf(L1DETINFnRow,L1DETCONposZ)
                        ilao = ilao + iDetInf(L1DETINFnRow,L1DETCONposZ)
                     endif
                  END DO
                  IF ( Above ) THEN
                     iPoWi(iLay) = ke + 1 ! next first hit
                  ELSE
                     iPoWi(iLay) = ke - 1
                  END IF
               END DO
            END DO
         END IF
c
      END DO
      END DO
c
c     print wire ranges for TFUs:
c
      DO iTFUpc = 1,L1PARntfu                       ! loop over all TFUs
         iTFU = L1PCstor(L1PCtfup(iTFUpc)+L1PCnum)  ! get TFU num
         nCon = L1DEFtfudef(L1TFUnsec,iTFU)
         DO iCon = 1,nCon                           ! loop over all connections
            iPo = L1DETCONdetpo(iCon,iTFU)          ! get pointer to range info
         IF(L1PARprnlev.eq.8)
     &           WRITE(L1LUNprn,900) 
     &           L1DETCONstor(iPo+L1DETCONtfu),
     &           L1DETCONstor(iPo+L1DETCONdet),
     &           L1DETCONstor(iPo+L1DETCONsec),
     &           T1DETCONstor(iPo+L1DETCONx0),
     &           T1DETCONstor(iPo+L1DETCONxs),
     &           L1DETCONstor(iPo+L1DETCONnsing),
     &           L1DETCONstor(iPo+L1DETCONnORed)
 900        FORMAT(1x,'TFU',i3.3,' is connected to det/sec ',i3,'/',i3,
     &             ' x0/xs:',f5.0,'/',f5.0,
     &             ' sing.:',i3,' ORed:',i3)
            kk = L1DETCONrange+iPo
            DO i=1,L1DETCONstor(iPo+L1DETCONnsing),3
             IF(L1PARprnlev.eq.8)
     &            WRITE(L1LUNprn,910) 'Sing:',
     &             (L1DETCONstor(j+L1DETCONwrTFU),
     &              L1DETCONstor(j+L1DETCONlayer),
     &              L1DETCONstor(j+L1DETCONfirst),
     &              L1DETCONstor(j+L1DETCONlast),
     &              j=kk,kk+3*L1DETCONrangelen-1,L1DETCONrangelen)
               kk = kk + 3*L1DETCONrangelen
            END DO
            DO i=1,L1DETCONstor(iPo+L1DETCONnORed),3
             IF(L1PARprnlev.eq.8)
     &              WRITE(L1LUNprn,910) 'ORed:',
     &             (L1DETCONstor(j+L1DETCONwrTFU),
     &              L1DETCONstor(j+L1DETCONlayer),
     &              L1DETCONstor(j+L1DETCONfirst),
     &              L1DETCONstor(j+L1DETCONlast),
     &              j=kk,kk+3*L1DETCONrangelen-1,L1DETCONrangelen)
               kk = kk + 3*L1DETCONrangelen
            END DO
 910        FORMAT(3x,a5,3('(',i4.4,':',i2.2,',',i4.4,',',i4.4,')':))
         END DO
         iSup = L1DEFtfudef(L1TFUsup,iTFU)        ! super layer number of TFU
         IF(L1PARprnlev.eq.8)
     &        WRITE(L1LUNprn,920) iTFU,(iWrTFU(i,iTFU)-1,i=1,3),
     &        T1DETzSup(iSup)
 920     FORMAT(1x,'TFU',i3.3,
     &     ' ==> last used wires WM1,WM2,WM3: ',
     &     2(i4.4,','),i4.4,' z= ',f7.0)
      END DO
c
      RETURN
c
 1001 CONTINUE
      WRITE (L1LUNprn,*)
     &     'L1TFUIN ==> invalid stereo ang. det/lay/ang',
     &     jDet,layerC(i,1),rDetGeo(L1GEOINFsin_al,i)
      ierr = 1
      RETURN
c
c
      END
