*-- Author :    Hartwig Albrecht   05/04/95

      SUBROUTINE LIZEBR (I1, I2, ID, CTPL)

************************************************************************
*
* Description: List Q/IQ
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*  I1      in     Q(I1) ...
*  I2      in     ... Q(I2) will be listed on printers
*  ID      in     column number (0: all columns)
*  CTPL    in     printer: one of 'T','P','L'; 'F' means all formats.
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"
#include "auto/MEMA.fi"

      INTEGER I, I1, I2, I3, J, J1, JL, JR, NW, IA, IB, IC, ID,
     +        CHIND1, CHCMPN, LENOCC
      CHARACTER CTPL*(*), C4*4, C16*16, CREL*4, C80*80, CST(-1:2)*5,
     +  CTB(-2:4)*8, CNEW*4
      DIMENSION CREL(4)
      DATA CREL /'o->o', 'm->o', 'o->m', 'm->m'/
      DATA CST /'nwrds','statw','ncols','nrows'/
      DATA CTB /': par_to', ': sub_of', ' ',
     +  ': one_to_one', ': many_to_one', ' ', ': many_to_many'/

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEMA.ff"

      IF (I1 .LT. -8 .OR. I2 .GT. NZEBRA)  THEN
        C78 = 'LIZEBR: indices'
        CALL CH78BI (I1)
        CALL CH78CI (I2)
        CALL CH78BC ('must be between 0 and')
        CALL CH78BI (NZEBRA)
        CALL ME78WC (3524587)
        GO TO 900
      END IF

      I = I1
 10   IF (I .GT. I2)  GO TO 900

C inside Arte table ?

      DO 20 JL = 1, NARLNK
        IF (JLINK(JL) .EQ. 0)  GO TO 20
        IF (I .LT. JLINK(JL) - 8 .OR.
     +    I .GT. JLINK(JL) + IQ(JLINK(JL)-1))  GO TO 20

C get column and word number

        NW = I - JLINK(JL)
        IC = 0
        IF (NW .GT. 2 .AND.
     +    NW .LE. IQ(JLINK(JL)+1) * IQ(JLINK(JL)+2) + 2)  THEN
          IA = MOD (NW - 3, IQ(JLINK(JL)+1))
          IC = IA + 1
          IF (ID .NE. 0 .AND. ID .NE. IC)  GO TO 100
          IA = IA + IMEMO_MEMA(JL)
        END IF

        IF (ID .EQ. 0 .AND. (I .EQ. I1 .OR. (IMEMO_FLAG(JL) .LE. 0 .AND.
     +     (NW .EQ. 0 .OR. IC .EQ. 1))))  THEN
          C78 = 'Table'
          CALL CHHTOC (IQ(HQMEMO_NAME(1,JL)), C78(7:86))
          CALL CH78BC ('link')
          CALL CH78BI (JL)
          CALL CH78AC (CTB(IMEMO_FLAG(JL)))
          IF (IMEMO_FLAG(JL) .NE. 0 .AND.
     +      IMEMO_SUP(1,JL) .GT. 0 .AND.
     +      IMEMO_SUP(1,JL) .LE. NARLNK)  THEN
            CALL CHHTOC (IQ(HQMEMO_NAME(1,IMEMO_SUP(1,JL))), C80)
            CALL CH78BC (C80)
            IF (IMEMO_FLAG(JL) .GT. 0 .AND.
     +        IMEMO_SUP(2,JL) .GT. 0 .AND.
     +        IMEMO_SUP(2,JL) .LE. NARLNK)  THEN
              CALL CHHTOC (IQ(HQMEMO_NAME(1,IMEMO_SUP(2,JL))), C80)
              CALL CH78BC (C80)
            END IF
          END IF
          CALL ME78SP (CTPL)
        END IF
        GO TO 30

 20   CONTINUE
      JL = 0

 30   C78 = ' '
      CALL CH78BI (I)
      IF (JL .NE. 0)  THEN
        CALL CH78BI (NW)
        IF (IC .NE. 0)  THEN
          CALL CH78BC ('r')
          CALL CH78BI ((NW - 3) / IQ(JLINK(JL)+1) + 1)
          CALL CH78BC ('c')
          CALL CH78BI (IC)
        END IF
      END IF

      IF (LENOCC(C78) .LT. 25)  CALL CHRIGH (C78(1:25))
      CALL CH78BC ('|')

      CALL CHHTOC (IQ(I), C4)
      DO 40 J = 1, 4
 40    IF (ICHAR(C4(J:J)) .LT. 32 .OR.
     +     ICHAR(C4(J:J)) .GE. 128)  C4(J:J) = '`'

C The following only for IEEE floating representation!

      IF (IQ(I) .LT. -8388608 .OR. IQ(I) .GE. 0)  THEN
        IF (Q(I) .NE. 0.)  THEN
          IF (ABS(Q(I)) .GE. 1. .OR. ABS(Q(I)) .LT. 0.001)  THEN
            WRITE (C16, '(G16.5)')  Q(I)
          ELSE
            IF (ABS(Q(I)) .GE. 0.1)  THEN
              WRITE (C16, '(F16.5)')  Q(I)
            ELSE IF (ABS(Q(I)) .GE. 0.01)  THEN
              WRITE (C16, '(F16.6)')  Q(I)
            ELSE
              WRITE (C16, '(F16.7)')  Q(I)
            END IF
          END IF
          IF (C16(13:13) .EQ. 'E')  THEN
            IF (C16(15:15) .EQ. '0')  THEN
              C16(15:15) = C16(16:16)
              C16(16:16) = ' '
            END IF
            IF (C16(14:14) .EQ. '+')  THEN
              C16(14:14) = C16(15:15)
              C16(15:15) = C16(16:16)
              C16(16:16) = ' '
            END IF
          ELSE
            DO J = 16, 2, -1
              IF (C16(J:J) .EQ. '0')  C16(J:J) = ' '
              IF (C16(J:J) .NE. ' ')  GO TO 41
            END DO
          END IF
 41       CALL CHLEFT (C16)
        ELSE
          C16 = '0.0'
        END IF
      ELSE IF (IQ(I) .EQ. -8388608)  THEN
        C16 = 'INFINITY'
      ELSE
        C16 = 'NAN'
      END IF

      IF (JL .EQ. 0)  GO TO 80
      IF (I .GE. JLINK(JL) - 1 .AND. I .LE. JLINK(JL) + 2)  THEN
        CALL CH78BC (CST(I-JLINK(JL)))
        CALL CH78BI (IQ(I))
        CALL CH78BZ (IQ(I))
        GO TO 90
      END IF

      IF (CHIND1 (CTPL, 'F') .NE. 0)  GO TO 80
      IF (I .GT. JLINK(JL) + IQ(JLINK(JL)+1) *
     +    IQ(JLINK(JL)+2) + 2)  GO TO 80

      IF (IMEMO_FLAG(JL) .LT. -2 .OR. IMEMO_FLAG(JL) .GT.4)  THEN
        CALL CH78BC ('unknown table type')
        GO TO 80
      END IF

      IF (IMEMO_FLAG(JL) .GT. 0)    THEN
 50     CALL CH78BI (IQ(I))
        IF (MOD (I - JLINK(JL), 2) .EQ. 0 .AND.
     +      IMEMO_FLAG(JL) .LE. 3)  GO TO 90
        IF (MOD (I - JLINK(JL), 4) .EQ. 2)  GO TO 90
        I = I + 1
        GO TO 50
      END IF

      IF (IMEMA_TYPE(IA) .LE. 0 .OR. IMEMA_TYPE(IA) .GT. 11)  THEN
        CALL CH78BC ('unknown data type')
        GO TO 80
      END IF

      IF (IMEMA_TYPE(IA) .LE. 5 .OR.
     +    IMEMA_TYPE(IA) .EQ. 9)  THEN
        CALL CH78BI (IQ(I))
      ELSE IF (IMEMA_TYPE(IA) .EQ. 6 .OR.
     +         IMEMA_TYPE(IA) .GE. 10)  THEN
        CALL CH78BZ (IQ(I))
      ELSE IF (IMEMA_TYPE(IA) .EQ. 7)  THEN
        CALL CH78BC (C16)
      ELSE IF (IMEMA_TYPE(IA) .EQ. 8)  THEN
        CALL CH78BC ('''')
        J = LENOCC (C78)
        J1 = J
 60     C78(J+1:J+4) = C4
        IF (I .LE. I2 .AND.
     +      CHCMPN (IQ(HQMEMA_NAME(1,IA)), IQ(HQMEMA_NAME(1,IA+1)))
     +      .NE. 0 .AND. LENOCC (C78) .LE. N78MAX - 20)  THEN
          I = I + 1
          IA = IA + 1
          J = J + 4
          CALL CHHTOC (IQ(I), C4)
          IF (C4 .NE. ' ')  GO TO 60
          IB = IA
          DO I3 = I + 1, I2
            IB = IB + 1
            IF (CHCMPN (IQ(HQMEMA_NAME(1,IB)),
     +        IQ(HQMEMA_NAME(1,IB+1))) .EQ. 0)  GO TO 60
            CALL CHHTOC (IQ(I3), CNEW)
            IF (CNEW .NE. ' ')  GO TO 60
          END DO
          I = I3
        END IF
        CALL CHAPPC (C78(J1+2:), '''')
      END IF

      CALL CHHTOC (IQ(HQMEMA_NAME(1,IA)), C80)
      CALL CHAPBC (C78(35:), C80)

C pointers


C relations

      IF (IMEMA_TYPE(IA) .GT. 0 .AND.
     +    IMEMA_TYPE(IA) .LE. 4)  THEN
        IF (IMEMA_RELA(IA) .GT. 0 .AND.
     +    IMEMA_RELA(IA) .LE. NMEMO())  THEN
          CALL CHHTOC (IQ(HQMEMO_NAME(1,IMEMA_RELA(IA))), C80)
        ELSE
          C80 = 'unknown relation'
        END IF
        CALL CH78BC (C80)
 
        CALL CH78BC (CREL(IMEMA_TYPE(IA)))
        IF (IMEMA_RELT(IA) .GT. 0 .AND.
     +    IMEMA_RELT(IA) .LE. NMEMO())  THEN
          CALL CHHTOC (IQ(HQMEMO_NAME(1,IMEMA_RELT(IA))), C80)
        ELSE
          C80 = 'unknown table'
        END IF
        CALL CH78BC (C80)

        J = IQ(I)
        IF (IMEMA_TYPE(IA) .LE. 2 .OR. J .EQ. 0)  GO TO 90
        CALL CH78AC (':')

        JR = 0
        IF (IMEMA_TYPE(IA) .EQ. 4 .AND.
     +      JL .EQ. IMEMO_SUP(1,IMEMA_RELA(IA)) .AND.
     +      IC .EQ. IMEMO_POS(1,IMEMA_RELA(IA)))  JR = 2

 70     IF (J. EQ. 0)  GO TO 90
        IF (LENOCC (C78) .GE. N78MAX - 10)  THEN
          C78(N78MAX-2:N78MAX) = '...'
          GO TO 90
        END IF
        IF (J .LT. 0 .OR. J .GT. N_U(JLINK(IMEMA_RELA(IA))))  THEN
          CALL CH78BC ('wrong pointer')
          GO TO 90
        END IF
        CALL CH78BI (I_V(1+JR, J, JLINK(IMEMA_RELA(IA))))
        J = I_V(2+JR, J, JLINK(IMEMA_RELA(IA)))
        GO TO 70
      END IF
      GO TO 90

 80   CALL CH78BI (IQ(I))
      CALL CH78BC (C16)
      CALL CH78BZ (IQ(I))
      CALL CH78BC ('''')
      J = LENOCC (C78)
      CALL CH78AC (C4)
      CALL CHAPPC (C78(J+2:), '''')

 90   CALL ME78SP (CTPL)
      IF (JL .NE. 0 .AND. IC .EQ. IMEMO_OCOL(JL) .AND.
     +    IMEMO_FLAG(JL) .LE. 0 .AND. ID .EQ. 0)
     +    CALL MESELP ('Dend_out', CTPL)

 100  I = I + 1
      GO TO 10

 900  END

************************************************************************
* End of LIZEBR
************************************************************************
