#ifndef MuPixChamber_h
#define MuPixChamber_h 1

//## Class: MuPixChamber
//      /**Author:        Boris Fominykh
//
//      Date:             January 4, 2000
//
//      Class:            MuPixChamber
//
//      Base Class:       none
//
//      Description:
//      This class defines the fine structure of the pixel chambers */

typedef unsigned short Word;

class MuPixChamber
{
  public:
    //## Constructor
           MuPixChamber();
    //## Destructor
           ~MuPixChamber();

    //public methods
      //        /**Print the table */
      void Print();

// number of superlayers
  static const Word Sl = 4;
// max number of readout columns 
  static const Word Ny = 17;
// max number of connectors per pixel chamber
  static const Word Ncon = 24;
// number of bits in the connector
  static const Word Nbit = 16;
// max number of non-connected pixels in x and y directions
    Word NxM[Sl];
    Word NyM[Sl];
// number of pixels connected into one readout channel
    Word NxC[Sl];
    Word NyC[Sl];
// pixel chamber structure to describe a hole - number of
// readout channels in x-direction for one y row 
    Word NpixHole[Sl][Ny];
// x posisition of the connected pixel readout channel
    Word  Pnx1[Sl][Ncon][Nbit];
// y posisition of the connected pixel readout channel
    Word  Pny1[Sl][Ncon][Nbit];

  protected:

  private:

    //        /**Clear the arrays*/
      void Clear();
    //        /** Definition of the pixel chamber geometry near the hole */
      void PixHole();
    //        /** Definition of the pixel chamber connectors */
      void PixConn();
};

#endif





