** 
**  Author:  Rainer Mankel                     Created:  19-Jun-99
**           Humboldt University Berlin        Modified:
**  Email:   mankel@ifh.de                     HERA-B Collaboration
** 

      integer function diident(rt)

*     **** crude identification of RTRA entry
*     **** returns gcode, to be used for type display
*     **** NOT FOR ANALYSIS USE

      implicit none
#include "arte/Arte.fi"
#include "auto/RTRA.fi"

      integer rt, ! RTRA pointer of reconstructed particle
     +     charge, gcode, flag
      real lrtot

#include "arte/Arte.ff"
#include "auto/RTRA.ff"

      charge = 0
      gcode = 0

      flag = irtra_fit(rt)

      if (flag.eq.0) then       ! charged particle
         if (frtra_pf(rt).ge.0.) then
            charge = 1
         else
            charge = -1
         endif

         lrtot = frtra_lre(rt) + frtra_lrmu(rt)
     +        + 5.*frtra_lrpi(rt) + frtra_lrk(rt) + frtra_lrp(rt) 

         if (irtra_hmu(rt).ge.4) then  ! muon
            gcode = 5
         elseif (frtra_lee(rt).gt.0.3) then ! electron
            gcode = 2
         elseif (frtra_lrp(rt).gt.0.5 * lrtot) then ! proton
            gcode = 14
         elseif (frtra_lrk(rt).gt.0.5 * lrtot) then ! kaon
            gcode = 11
         else                   ! pion
            gcode = 8
         endif

         if (charge.lt.0) gcode = gcode + 1
            
      elseif (gcode.eq.6) then  ! photon
         gcode = 1
      else
         gcode = 0              ! undefined
      endif

      diident = gcode

      end
         
         

