*-- Author :    Rainer Mankel   16/12/95

      subroutine diplab(pl,chopt)

*     **** display detector plane body for plane "pl"
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"

      character*(*) chopt
      real xxx(5), yyy(5), wc(5,4), tg, xmin, xmax, ymin, ymax
      real x1,x2,x3,x4,y1,y2,y3,y4
      integer ii, pl, isl, cmp
      logical llist

#include "auto/GEO.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"

      llist   = index(chopt,'L').gt.0
      isl = ogede_gesl(pl)
      if (isl.le.0) print *,' () diplab: pl,isl=',pl,isl
      cmp = igesl_cmp(isl)

      if (cmp.eq.5) then        ! no RICH here
**         print *,' diplab: unsupported cmp=', cmp
         go to 999
      endif

*     **** choose borders
      if (lsenszg) then
         xmin = fgede_sxmn(pl)
         xmax = fgede_sxmx(pl)
         ymin = fgede_symn(pl)
         ymax = fgede_symx(pl)
      else
         xmin = fgede_xmin(pl)
         xmax = fgede_xmax(pl)
         ymin = fgede_ymin(pl)
         ymax = fgede_ymax(pl)
      endif

      if (llist) then
       print *,' diplab: display plane ',pl,
     +        ' cmp= ',cmp,
     +        ' isl=',isl
       print *,'            borders xmin/mx,ymin/mx=',
     +        xmin,xmax,ymin,ymax
      endif

*     **** tan(stereo angle)
      if (fgede_cos(pl).ne.0.) then
       tg = fgede_sin(pl) / fgede_cos(pl)
      else
       tg = fgede_sin(pl) / 0.00001
      endif

      if (.not.lstereozg) then
*        **** bypass stereo planes
         if (cmp.ne.1.and.cmp.ne.6) then
            if (abs(fgede_sin(pl)).gt.0.05
     +           .or.abs(fgede_rot(2,pl)).gt.0.05)
     +           go to 999
         endif
      endif

*     **** corners of plane (using world coordinates)
      call igset('PLCI',coplbzg)
      call isln(15)

      if (igede_shp(pl).le. 2 .or. igede_shp(pl).eq.10
     +.or.igede_shp(pl).eq.42 .or. igede_shp(pl).eq.34) then
*        **** basic shape
         wc(1,1) = xmin
         wc(2,1) = ymin
         wc(3,1) = fgede_zmin(pl)

         wc(1,2) = xmax
         wc(2,2) = ymin
         wc(3,2) = fgede_zmin(pl)

         wc(1,3) = xmax
         wc(2,3) = ymax
         wc(3,3) = fgede_zmin(pl)

         wc(1,4) = xmin
         wc(2,4) = ymax
         wc(3,4) = fgede_zmin(pl)

*        **** shear shape for epiped
         if (igede_shp(pl).eq.10) then
            do ii=1,4
               wc(1,ii) = wc(1,ii) + tg * wc(2,ii)
            enddo
         endif
      else
         print *,' () diplab: unsupported shape, shp, pl=',
     +        igede_shp(pl), pl
         go to 999
      endif

      if (fgede_rot(1,pl).ne.1.) then
*        **** additional rotation
         do ii=1,4
*           **** use 2D rotation matrix
            call diroxy(wc(1,ii),fgede_rot(1,pl),-fgede_rot(2,pl))
         enddo
      endif

*     **** projection
      do ii=1,4

         if (wc(3,ii).ne.0.) then
            wc(4,ii) = atan( wc(1,ii) / wc(3,ii) )
            wc(5,ii) = atan( wc(2,ii) / wc(3,ii) )
         else
            wc(4,ii) = 20000.
            wc(5,ii) = 20000.
         endif

         call dipro5(wc(1,ii),xxx(ii),yyy(ii))
      enddo

*     **** close the parallelogram
      xxx(5) = xxx(1)
      yyy(5) = yyy(1)


      if (lsclipzg) then
         x1 = xxx(1)
         x2 = xxx(2)
         x3 = xxx(3)
         x4 = xxx(4)
         y1 = yyy(1)
         y2 = yyy(2)
         y3 = yyy(3)
         y4 = yyy(4)
         if (amax1(x1,x2,x3,x4).lt.xminzg) go to 998
         if (amin1(x1,x2,x3,x4).gt.xmaxzg) go to 998
         if (amax1(y1,y2,y3,y4).lt.yminzg) go to 998
         if (amin1(y1,y2,y3,y4).gt.ymaxzg) go to 998
      endif

*     **** draw plane
      call isplci(int(coplbzg))
      call igsg(1)
      call isln(1)

*     **** draw plane volume if opaque option active
      if (lopaquezg) then
         call igset('PLCI',coplvzg)
         call igset('FACI',coplvzg)
         call igset('FAIS',1.)
         call igset('BORD',0.)
         call ifa(5,xxx,yyy)
      endif
*     **** draw plane border
      call igset('PLCI',coplbzg)
      call igset('FAIS',0.)
      call igset('LWID',1.)
      call ipl(5,xxx,yyy)

 998  call isfaci(0)
      call isfais(0)

**    call iuwk(0,1)
**    call igsa(1)

 999  end


