// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerHitWire
// node class for drift chamber hit

#ifndef rangerHitWire_HH
#define rangerHitWire_HH

#include "rang/Hit.hh"
#include "rang/FitMode.hh"
#include "CLHEP/Matrix/Matrix.h"
#include "CLHEP/Matrix/Vector.h"

class rangerHitWire : public rangerHit {

public:

  rangerHitWire();
  rangerHitWire(ArtePointer<RHIT> rhit,rangerFitMode fm);
  rangerHitWire(ArtePointer<HITB>   hb,rangerFitMode fm);
  ~rangerHitWire();

  void projectP(HepVector& resid,HepMatrix& HH,rangerStateP* s);
  void projectPI(HepVector& resid,HepMatrix& HH,rangerStatePI* s);
  void projectL(HepVector& resid,HepMatrix& HH,rangerStateL* s);
  void projectLI(HepVector& resid,HepMatrix& HH,rangerStateLI* s);

  inline int dim() const {return 1;};         // dimension of measurement
  void updInternal();  // update internal degrees of freedom

  inline int getLRSign() const { return LRSign ; } ;
  inline void setLRSign(double s) { LRSign = (s>=0) ? 1 : -1; } ;
  inline void flipLRSign() { LRSign *= -1 ; } ;
private:

  int LRSign;

};

#endif
