// 
//  Author:  Rainer Mankel                     Created:  23-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rgwibord_
// Fortran interface to getter functions rangerDomWin::xmin()...
// rangerDomWin::ymax() which return borders of a given domain window.

// Input parameter: pointer to domain window.
// Output parameters: xmin...ymax

// See also rgdlwbord.C

#include "rang/DomLay.hh"
#include "rang/DomWin.hh"

extern "C" {
  void rgwibord_(rangerDomWin*& dw,  // domain window (input)
		 float& xmin,        // lower x border of window
		 float& xmax,        // upper x 
		 float& ymin,        // lower y
		 float& ymax) {      // upper y
    if (dw) {
      xmin = dw->xmin();
      xmax = dw->xmax();
      ymin = dw->ymin();
      ymax = dw->ymax();
//       cout << "rgwibord: xmin=" << xmin << " xmax=" << xmax << endl;
    }
    else {
      cout << "rgwibord: invalid dw=" << dw << endl;
    }
  }
}



    



