
*-- Author :    Rainer Mankel   27/05/96

#define STACK_OVER_IGNORE 

      subroutine tfdzone2(base,method,zone,direction,nmax,
     +                    target_vec,n_target)

*     **** return vector of possible target domain layers
*     **** using stack
      implicit none
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"

      integer base,              ! number of starting domain layer
     +        method,            ! navigation method used
     +        zone,              ! navigation depth
     +        direction,         ! navigation direction
     +        nmax,              ! dimension of target_vec
     +        target_vec(nmax),  ! returned vector of target planes
     +        n_target           ! number of returned target planes

      integer pdn,step,i_stack,dl_current,izone,prv,nav1,nav2,iistack,
     +     ii,win
      logical init              ! .true. if navigation table is read

      integer max_stack, n_stack
      logical mult_gen
      parameter (max_stack=50,mult_gen=.false.)
      integer dl_stack(max_stack) ! dl of stack entry (=0 for win)
      integer win_stack(max_stack) ! dw of stack entry (if dl=0)
      integer zone_stack(max_stack) ! zone of stack entry
      integer wgen_stack(max_stack) ! window generation
      integer min_domain,max_domain
#include "arte/Arte.fi"
#include "auto/GESL.fi"
#include "auto/GEDE.fi"

      save init
      data init /.false./

#include "arte/Arte.ff"
#include "auto/GESL.ff"
#include "auto/GEDE.ff"

      min_domain = dom_dpc(1)
      max_domain = dom_dpc(n_dpc)

*     **** return zone vector
      n_target = 0

*     **** clear stack
      n_stack = 0
      i_stack = 0

*     **** try to resolve within current window
      dl_current = base
      do 10 izone=1,zone
         if (direction.eq.+1) then
            prv = nxtlay_dl(method,dl_current)
         else
            prv = prvlay_dl(method,dl_current)
         endif
**         print *,' current window,dl_current,prv=', dl_current,prv
         if (prv.eq.0) then     ! put nav target windows on stack

            if (direction.eq.+1) then
               nav1 = navf1_dw(win_dl(dl_current)) ! nav targets forward
               nav2 = navf1_dw(win_dl(dl_current))
     +              +nnavf_dw(win_dl(dl_current))-1
            else
               nav1 = navb1_dw(win_dl(dl_current)) ! nav targets backwrd
               nav2 = navb1_dw(win_dl(dl_current))
     +           +nnavb_dw(win_dl(dl_current))-1
            endif

            do pdn=nav1,nav2    ! loop over navigation targets
               win = wintarg_dn(pdn)
               if (method.eq.1.or.(
     +              domain_dw(win).ge.min_domain.and.
     +              domain_dw(win).le.max_domain)) then
                  n_stack = n_stack + 1
                  dl_stack(n_stack) = 0
                  zone_stack(n_stack) = izone - 1
                  win_stack(n_stack) = wintarg_dn(pdn)
                  wgen_stack(n_stack) = 1
               endif
            enddo
            go to 11
         endif
         dl_current = prv
 10   continue

      n_target = 1
      target_vec(1) = dl_current
      go to 900

 11   continue

      if (diag_level.ge.6) then
         print *,' stack after current:'
         do ii=1,n_stack
            print *,' ii,zone_stack(ii),win_stack(ii),',
     +           'wgen_stack(ii)=',
     +           ii,zone_stack(ii),win_stack(ii),
     +           wgen_stack(ii)
         enddo
      endif


*     **** loop over stack
      do 20 iistack=1,max_stack
         if (i_stack.lt.n_stack) then
            i_stack = i_stack + 1
         else
            go to 21
         endif

*        **** try to resolve within this window
         do izone=zone_stack(i_stack)+1,zone
            if (izone.eq.(zone_stack(i_stack)+1)) then
               if (direction.eq.+1) then
                  prv = layer1_dw(method,win_stack(i_stack))
               else
                  prv = layerlst_dw(method,win_stack(i_stack))
               endif
            else
               if (direction.eq.+1) then
                  prv = nxtlay_dl(method,dl_current)
               else
                  prv = prvlay_dl(method,dl_current)
               endif
            endif
            if (diag_level.ge.6) then
               print *,' i_stack,win_stack,dl_current,prv=',
     +              i_stack,win_stack(i_stack),dl_current,prv
            endif
            if (prv.eq.0) then  ! put window on stack

               if (direction.eq.+1) then
                  nav1 = navf1_dw(win_stack(i_stack)) ! nav targets fwrd
                  nav2 = navf1_dw(win_stack(i_stack))
     +                 +nnavf_dw(win_stack(i_stack))-1
               else
                  nav1 = navb1_dw(win_stack(i_stack)) ! nav targets bwrd
                  nav2 = navb1_dw(win_stack(i_stack))
     +                 +nnavb_dw(win_stack(i_stack))-1
               endif

               if (.not.mult_gen) then ! no multiple window expansion
                  nav2 = min0(nav2,nav1+1)
               endif

               do pdn=nav1,nav2 ! loop over navigation targets

                  if (n_stack.lt.max_stack) then
                     n_stack = n_stack + 1
                  else
#ifdef STACK_OVER_IGNORE
                     go to 900 
#endif
                     print *,' tfdzone2: stack overflow!!'
                     print *,' base,method,zone=',base,method,zone
                     do ii=1,n_stack
                        print *,' ii,zone_stack(ii),win_stack(ii),',
     +                       'wgen_stack(ii)=',
     +                       ii,zone_stack(ii),win_stack(ii),
     +                       wgen_stack(ii)
                     enddo
                     go to 900
                  endif
                  dl_stack(n_stack) = 0
                  zone_stack(n_stack) = izone - 1
                  win_stack(n_stack) = wintarg_dn(pdn)
                  wgen_stack(n_stack) = wgen_stack(i_stack) + 1
               enddo
               go to 20
            endif
            dl_current = prv
         enddo

         n_target = n_target + 1
         target_vec(n_target) = dl_current

 20   continue

      print *,' tfdzone2: loop ended without stack finished!!!'

 21   continue                  ! stack has been finished off



 900  if (diag_level.ge.6) then
         print *,' tfdzone: final result: n_target=', n_target
         print *,
     +        '         target_vec=',
     +        (target_vec(step),secshad_dw(win_dl(target_vec(step))),
     +        step=1,n_target)
      endif

      end
