*-- Author :    A. Spiridonov   14.06.99

*#define EXT_STAT_MCRICH

      subroutine tfextstat()

*     **** pattern recognition efficiencies etc for external tracking

#include "arte/Arte.fi"
#include "auto/RTRA.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"

#include "pris/zpstat.fi"
#include "rang/zfout.fi"
#include "rang/zfextse.fi"
#include "auto/RSEG.fi"
#include "arte/RSEG_cmp.fi"

      integer ncounter, code_eplus, code_eminus, code_muplus,
     +        code_muminus, tpname
      parameter (ncounter=9)
                 ! counter=1  for e+-
                 !         2  for mu+-
                 !         3  for l+-
                 !         4  for pi+-
                 !         5  for J/Psi
                 !         6  for K0S
                 !         7  for B0
                 !         8  for charged tracks
                 !         9  for ghosts

      integer counter_mc_evt(ncounter), ! reference mc objects per evt
     +        counter_mc_all(ncounter), !           ||        (all evts)
     +        counter_rc_evt(ncounter), ! reference rc objects per evts
     +        counter_rc_all(ncounter), !           ||        (all evts)
     +        counter_ef_all(ncounter), ! defined efficiency evts
     +        counter_ge_evt(ncounter), ! generated mc objects per evt
     +        counter_ge_all(ncounter)  !           ||        (all evts)
      
      real    counter_evtef (ncounter), ! current evt efficiencies
     +        counter_allef (ncounter), ! current run efficiencies
     +        accumul_ef_all(ncounter)  ! summed efficiency   (all evts)
      integer counter_bgen_evt  ! golden Bs
      integer counter_bgen_all
      integer counter, ii, mc, jaux, rc, nrc, ialia, it, gold, jgold,
     +        mcgold, counter_lep, lepton, n_events
      character*20 cname
      real mass, charge, pmc, fracmc
      character*20 counter_name(ncounter) ! name of counter
      logical lrefpat(7,maxgold), lrc(7,maxgold)

      data n_events /0/

      data counter_name / 'golden e+-', 'golden mu+-', 'golden l+-',
     +      'golden pi+-', 'golden J/Psi', 'golden K0S', 'golden B0',
     +      'charged tracks', 'ghosts' /

      data counter_mc_evt /ncounter*0/,
     +     counter_mc_all /ncounter*0/,
     +     counter_rc_evt /ncounter*0/,
     +     counter_rc_all /ncounter*0/,
     +     counter_ef_all /ncounter*0/,
     +     accumul_ef_all /ncounter*0./,
     +     counter_ge_evt /ncounter*0./,
     +     counter_ge_all /ncounter*0./,
     +     counter_bgen_all  /0/

      integer imc

      save n_events, counter_mc_evt, counter_mc_all, counter_rc_evt,
     +  counter_rc_all, counter_ef_all, accumul_ef_all, counter_name,
     +     counter_bgen_evt, counter_bgen_all, counter_ge_evt,
     +     counter_ge_all
#include "arte/Arte.ff"
#include "auto/RTRA.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"
#include "auto/RSEG.ff"

      if (n_events.eq.0) then
         code_eplus  = tpname('e+')
         code_eminus = tpname('e-')
         code_muplus = tpname('mu+')
         code_muminus = tpname('mu-')
         if (min0(code_eplus,code_eminus,code_muplus,code_muminus)
     +        .le.0.or.
     +        max0(code_eplus,code_eminus,code_muplus,code_muminus)
     +        .gt.ntopp()) then
            print *,' () tfextstat: invalid topp pointer ',
     +           code_eplus,code_eminus,code_muplus,code_muminus
            stop 'tfextstat'
         endif
      endif

      n_events = n_events + 1

      do counter=1,ncounter         ! reset event scope counters
       counter_mc_evt(counter) = 0
       counter_rc_evt(counter) = 0
       counter_ge_evt(counter) = 0
      enddo
      counter_bgen_evt = 0

      if(N_ext_seed.le.0) go to 100
      nrc = 0

#ifdef EXT_STAT_MCRICH
      do ii=1,N_ext_seed  ! loop over external seeds
        if(track_MC(ii).gt.0) then  ! reference seed                 
          if(seg_OT(ii).gt.0) then
            call tfremcse(seg_OT(ii),imc,fracmc) ! locate MC particle again
            if(imc.eq.track_MC(ii).and.fracmc.ge.0.7) then
              nrc = nrc + 1
            end if
          end if
          if(ii.eq.N_ext_seed.or.seg_ECAL(ii).ne.seg_ECAL(ii+1)) then
            counter = 8  ! charged particles
            counter_mc_evt(counter) = counter_mc_evt(counter) + 1
            if (nrc.gt.0) then
              counter_rc_evt(counter) = counter_rc_evt(counter) + 1
            endif
            nrc = 0
          end if
        end if                       ! end of reference seed
      enddo ! external seeds

#else
      do ii=1,N_ext_seed  ! loop over external seeds                 
        if(seg_OT(ii).gt.0) then
          if(iand(irseg_cmp(seg_OT(ii)),rsegc_bitsign).eq.0) then  !ifnotkilled
            call tfremcse(seg_OT(ii),imc,fracmc) ! fraction of good hits 
            if(fracmc.ge.0.7) then
              nrc = nrc + 1
            end if
            counter = 8  ! charged particles
            counter_mc_evt(counter) = counter_mc_evt(counter) + 1
            if (nrc.gt.0) then
              counter_rc_evt(counter) = counter_rc_evt(counter) + 1
            endif
            nrc = 0
          end if                     ! end of not killed
        end if                       ! end of seed produce segment in OT
      enddo ! external seeds

#endif

      do counter=1,ncounter
*      **** event-based efficiencies
       if (counter_mc_evt(counter).gt.0) then
        counter_ef_all(counter) = counter_ef_all(counter) + 1
        counter_evtef(counter) = float(counter_rc_evt(counter))
     +                         / float(counter_mc_evt(counter))
        accumul_ef_all(counter) = accumul_ef_all(counter)
     +                                 + counter_evtef(counter)
       else
        counter_evtef(counter) = 0.
       endif
*      **** update all counters
       counter_mc_all(counter) = counter_mc_all(counter)
     +                         + counter_mc_evt(counter)
       counter_rc_all(counter) = counter_rc_all(counter)
     +                         + counter_rc_evt(counter)
       counter_ge_all(counter) = counter_ge_all(counter)
     +                         + counter_ge_evt(counter)

       if (counter_mc_all(counter).gt.0) then
        counter_allef(counter) = float(counter_rc_all(counter))
     +                         / float(counter_mc_all(counter))
       else
        counter_allef(counter) = 0.
       endif
      enddo ! updating of counters

      counter_bgen_all = counter_bgen_all + counter_bgen_evt

*     **** printout
*      if (leff_zfout) then
  100 continue
       print 101, n_events,
     +            (counter_name(counter),counter_mc_evt(counter),
     +            counter_rc_evt(counter),100.*counter_evtef(counter),
     +            counter_mc_all(counter),
     +            counter_rc_all(counter),100.*counter_allef(counter),
     +            counter_ge_all(counter),
     +                               counter=8,8)
       print 102


 101   format(//
     + ' |=====================',
     + '====================================================| '/
     + ' |       statis',
     + 'tics from tfextstat   nevents=',i6,'                        |'/
     + ' |=====================',
     + '====================================================|'/
     + ' | Counter     ',
     + '    MC(evt) RC(evt) ef(evt)  MC(run) RC(run) ef(run)',
     +      '    gen ','|'/
     + 9(' | ',a15,2i7,f7.2,5x,2i7,f7.2,i9,' |'/),
     + ' |=====================',
     + '====================================================| '//)
 102   format(
     + ' |=====================',
     + '====================================================| '/)

*      endif

 999  end
