// ********************************************************************
//
//  Routine:      rc99Match
//  Author:       T. Oest
//
//  Description:  steering routine for matching
//
//  Modification:
//  -- OTR-ECAL match added                      14/01/00 O.Igonkina
//  -- OTR match added                           06/12/99 O.Igonkina
//  -- remove rc99MarpleRtra, track selection is done
//     in rc99inventRTRA.C                       26/01/00 T.Oest
//
// ********************************************************************

// includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include "marple/marple.hh"

#include "arte/arte.hh"
#include "reco/rcflags.hh"

void rc99SelRTRA();

//
// function
//
int rc99Match(){

//-----------------------------------------------------------------
//   fit98 matching
//-----------------------------------------------------------------

  rc99SelRTRA();

//-----------------------------------------------------------------
//   marple matching
//-----------------------------------------------------------------
  if (matchMARPLEVdsEcal){
    static float Ktrig = 0.0;
   matchsvdecal_(& Ktrig);
  };
  if (matchMARPLEVdsRich)  matchsvdrich_();
  if (matchMARPLEVdsOtr)  matchsvdot_();
  if (matchMARPLEOtrRich)  matchotrrich_();
  if (matchMARPLEOtrEcal)  matchotrecal_();
  if (matchMARPLEEcalRich){
   static float Ktrig = 0.0;
   static float RichSb = 0.0;
   matchrichecal_(& Ktrig, & RichSb);
  };

return 0;
};


