// *********************************************************************
//
//  Routine:      rcerror
//  Author:       T.Oest
//
//  Description:  check the error flag
//
//
//  Modification:
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "reco/rcflags.hh"
#include "reco/rcerrorflag.h"

//*****************************************************************
// function
//*****************************************************************

unsigned int rcerror(char * module) {

  int len = strlen(module);
  char * Cmodule;
  Cmodule   = (char *) malloc(len+1);
  Cmodule[len] = 0;

  if(len>0) for(int i=0; i<len; i++) Cmodule[i] = toupper(module[i]);

//==================================================================
//  
///==================================================================

  unsigned int checkerror = 0;

  if (len == 4 && !strncmp(Cmodule,"RSEG" ,4)){
     checkerror |=  RECO_RSEG_VDS;
     checkerror |=  RECO_RSEG_OTR;
     checkerror |=  RECO_RSEG_ITR;
  };
  if (len == 4 && !strncmp(Cmodule,"RTRA",4)){
      checkerror |=  RECO_RTRA_CHRG;
      checkerror |=  RECO_RTRA_NEUT; 
  };

  if (!strncmp(Cmodule,"RSEG_VDS",8) || !strncmp(Cmodule,"RSEG_SVD",8))
     checkerror |=  RECO_RSEG_VDS;
      
  if (!strncmp(Cmodule,"RSEG_OTR",8)) checkerror |=  RECO_RSEG_OTR;
  if (!strncmp(Cmodule,"RSEG_ITR",8)) checkerror |=  RECO_RSEG_ITR;

  if (!strncmp(Cmodule,"RCCL"    ,4)) checkerror |=  RECO_RCCL;

  if (!strncmp(Cmodule,"RTRA_CHRG",9)) checkerror |=  RECO_RTRA_CHRG;
  if (!strncmp(Cmodule,"RTRA_NEUT",9)) checkerror |=  RECO_RTRA_NEUT;

  if (!strncmp(Cmodule,"PID_ECAL" ,8)) checkerror |=  RECO_PID_ECAL;
  if (!strncmp(Cmodule,"PID_MUON" ,8)) checkerror |=  RECO_PID_MUON;
  if (!strncmp(Cmodule,"PID_RICH" ,8)) checkerror |=  RECO_PID_RICH;
  if (!strncmp(Cmodule,"PID_TRD"  ,7)) checkerror |=  RECO_PID_TRD;

  if (!strncmp(Cmodule,"RVER_MAIN",9)) checkerror |=  RECO_RVER_MAIN;
  if (!strncmp(Cmodule,"RVER_K0S" ,8)) checkerror |=  RECO_RVER_K0S;


 free(Cmodule);

//==================================================================
// check error flag  
//==================================================================

  if (ArteTable<EVRC>::size() > 0){
   ArtePointer<EVRC> evrc( ArteTable<EVRC>::size());

   return evrc->errmask & checkerror;
   
  };


 return 0xFFFFFFFF;

};

