#include "dq/DQ.h"
#include "dq/DQ_RICH.h"
#include "rhp.h"
#include <stdio.h> 
#ifndef M_PI 
#define M_PI           3.14159265358979323846  /* pi */                       
#endif

extern int RITERalign;
                                         
int RITERalignment(){
  int nbin = 100;

  for  (int i=0; i<80 ;i++){      
    char tmp[50];    
    sprintf(tmp,"RICH mirror spherical %d",i);  
    rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 300+i),tmp,nbin,- M_PI , M_PI ,nbin,0.03,0.06);
  }

  for  (int i=0; i<36 ;i++){      
    char tmp[50];
    sprintf(tmp,"RICH mirror planar %d",i);
    rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 400+i),tmp,nbin,-M_PI,M_PI,nbin,0.03,0.06);
  }

  return 0;
}

int   RITERhisto=0;                                         
int RITERhbook(){

  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 232),"RICH Nb:Nsignal",100,0,100,100,0,100);

  /// cherenkov angles
  float min=0.03;
  float max=0.07;
  int   bin=100;
  
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 204),
	     "RICH: 1phot. thc distrib. M16", bin,min,max );
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 205),
	     "RICH: 1phot. thc distrib. M4", bin,min,max );
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 206),
	     "RICH: 1phot. thc distrib. weighted M16", bin,min,max );
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 207),
	     "RICH: 1phot. thc distrib. weighted M4", bin,min,max );

  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 1001),
	     "RICH: 1phot. thc vs fic weighted M16", bin,-M_PI,M_PI, bin,min,max );
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 1002),
	     "RICH: 1phot. thc vs fic weighted M4" , bin,-M_PI,M_PI, bin,min,max );
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 1003),
	     "RICH: expected number of photons", 100, 0, 100 );

  RITERhisto=1;
  if  (RITERalign)  RITERalignment();
  return 0;
};











