#ifndef _riter_beamshroud_h_
#define _riter_beamshroud_h_
#include <riter/RITER.hh>
#include <rich/rich.h>

/// description of the beam shroud  
class RITERBeamshroud {
protected:
  /// center of the proton beam shroud
  RITERVec  pbs_rc;
  /// radius of the proton beam shroud
  float  pbs_r;

public:

  /// constructor
  RITERBeamshroud(){
    RICHVessel &rv = *RICH_Vessel;
    pbs_rc   = toRITERVec(rv.ProtonBeamShroud().x0());
    pbs_r    = rv.ProtonBeamShroud().radius();
  }
  /// destructor
  ~RITERBeamshroud(){};
  /// returns beam direction
  RITERVec GetBeamDir()   { return  pbs_rc; };
  /// returns beam radius
  float      GetBeamRadius(){ return  pbs_r; };
};

#endif
