#ifndef _riter_hits_h_
#define _riter_hits_h_
/// desciption of a photon hit
class RITERHits { 
private:
public:
  /// photon hit virtual plane
  RITERVec rf;  
  /// angular error (sigma)
  float  sig2;     
  /// photon weight (channel efficiency, occupancy);
  float  utez; 
  /// photon weight after iteration;   
  float  w;    
  /// PMT type
  int pmtype;
  /// constructor of the class 
  RITERHits(const RITERVec &r,float sigma2=0.,float weight=1.,int pmttype=0){
    rf     = r;
    sig2   = sigma2;
    utez   = weight;
    w      = weight;
    pmtype = pmttype;
  };
  /// empty constructor
  RITERHits(){};
  /// destructor
  ~RITERHits(){};
  /// weight of the hit
  inline float    Weight(){  return utez;  }
  /// sigma of the hit
  inline float Sigma2() {  return sig2; }
  /// return virtual position of the hit on the photon detector
  inline RITERVec Position(){  return rf; }
  /// return type of the pmt 
  inline int Type(){ return pmtype; };
}; 

#endif



