#ifndef _riter_pmt_h_
#define _riter_pmt_h_
#include <riter/RITER.hh>

/// description of the pmt channel
class RITERPmt {
private:
  /// virtual position of the hit
  RITERVec r;
  /// sigma of the hit
  float sig;
  ///
  float eff;
  /// type of the PMT { 1 m4,0 m16,-1 not connected, -2 hot , -3 dead }
  int type;
  /// number of hits - not relevant for the riter
  int nh;
public:

  /// constructor
  RITERPmt(){ nh=0;sig=0;eff=0;type=-1;};
  /// destructor
  ~RITERPmt(){};
  /// sets the pmt parameters 
  int Set(RITERVec r_, int type_, float sig_=0,float eff_=0, int nh_=0) {
    r=r_;
    sig=sig_;
    eff=eff_;
    nh=nh_;
    type=type_;
    return 0;
  }
  /// returns pmt virtual position channel 
  RITERVec Position()   { return r;   };
  /// returns pmt Type 
  int        Type()       { return type;};
  /// returns sigma of the pmt channel 
  float      Sigma()      { return sig; };
  /// returns efficiency of the pmt channel 
  float      Efficiency() { return eff; };
  /// returns number of hits
  int        Hits()       { return nh; };

};

#endif






