*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :   T.Lohse
c
c------------------------------------------------------------
c
c       subroutine:   VTSUMN(iv,maskp,par,cov,flag)
c
c       input:    iv          =  vertex index         Int
c                 maskp       =  particle mask        Int
c
c       output:   par(5)   = total momentum           R*8
c                      1,2        = slope_x,slope_y
c                      3,4        = impact_x,impact_y
c                      5          = momentum
c                 cov(5,5) = cov(par)                 R*8
c                 flag        < 0 if fail             Int
c
c       action:   add momenta of all particles on vertex iv
c                 selected by maskp(i)=1
c
c------------------------------------------------------------
c
      subroutine  VTSUMN ( iv, maskp, par, cov, flag )

      implicit none

#include "vt/vtdat.fi"
      integer i3
      parameter (i3=3*ntrk+3)

      integer iv, maskp(ntrk), flag
      double precision 
     1  par(5), cov(5,5)

      integer np, n, i, j, k, l, nn, mm, l1, l2
      integer ic
      integer flag1

      double precision 
     1  parn(i3), covn(i3,i3), chi2m
      double precision 
     1  sum

      flag = -1
      if (iv.gt.nvtmax)  goto 999
      if ( .not. vtset(iv) )   goto 999
      n = ntr(iv)
      if ( fit(iv) .ne. 2 ) then
        call VTFIT(iv,1,flag1)
        if (flag1.lt.0)  goto 999
      endif

      ic = nconst(iv)
      if (ic.lt.0.or.ic.gt.ncomax)   goto 999

c
c---> fill general state vector and covariance matrix
c
      if (ic.gt.0) then
        fitm(iv) = 0
        call VTMASS(iv,parn,covn,chi2m,flag1)
        if (flag1.lt.0)              goto 999
      else
        parn(1) = xvs(1,iv)
        parn(2) = xvs(2,iv)
        parn(3) = xvs(3,iv)
        j = 4
        do  k = 1, n
          parn(j)   = qvs(1,iv,k)
          parn(j+1) = qvs(2,iv,k)
          parn(j+2) = qvs(3,iv,k)
          j = j + 3
        enddo

        do  i = 1, 3
          do  j = 1, 3
            covn(i,j) = CS(i,j,iv)
          enddo
        enddo
        do  k = 1, n
          nn  = 3*k
          do  i = 1, 3
            do  j = 1, 3
              covn(nn+i,nn+j) = DS(i,j,iv,k)
              covn(nn+j,nn+i) = DS(i,j,iv,k)
              covn(nn+i,j)    = ES(i,j,iv,k)
              covn(j,nn+i)    = ES(i,j,iv,k)
            enddo
          enddo
        enddo

        do  k = 1, n-1
          nn  = 3*k
          do  l = k+1, n
            mm  = 3*l
            do l1 = 1, 3
              do l2 = 1, 3
                sum = 0.d0
                do  i = 1, 3
                  sum = sum - ES(l1,i,iv,k)*F(l2,i,iv,l)
                enddo
                covn(nn+l1,mm+l2) = sum
                covn(mm+l2,nn+l1) = sum
              enddo
            enddo
          enddo
        enddo

      endif

c
c---> sort out those particles selected by maskp
c
      np = 0
      do  i = 1, n
        if ( maskp(i).gt.0 ) then
          np = np + 1
          do  j = 1, 3
            parn(3*np+j) = parn(3*i+j)
          enddo
          do  l1 = 1, 3
            do  l2 = 1, 3
              covn(l1,3*np+l2) = covn(l1,3*i+l2)
              covn(3*np+l1,l2) = covn(3*i+l1,l2)
            enddo
          enddo
          k  = 0
          do  j = 1, n
            if ( maskp(j).gt.0 ) then
              k = k + 1
              do  l1 = 1, 3
                do  l2 = 1, 3
                  covn(3*np+l1,3*k+l2) = covn(3*i+l1,3*j+l2)
                enddo
              enddo
            endif
          enddo
        endif
      enddo

c
c---> add momenta of selected tracks
c
      call VTSUMP(np,parn,covn,par,cov, flag1)
      if (flag1.lt.0) goto 999

      flag = 0
      return

  999 continue

      return
      end
