#include <stdio.h>
#include <stdlib.h>
#include "wax/OTrDecode.h"
#include <string.h>
#ifdef USE_ARTE
  #include <arte/Arte.h>
  #include <arte/ArteUtil.h>
  #include <auto/GEDE.h>
  #include <auto/GESL.h>
#endif

typedef struct{
  unsigned short asd_first_chan;
  unsigned short mod_first_wire;
  unsigned short mod_last_wire;
  char           side;
  unsigned char  crate;  
  unsigned char  slot;
  unsigned char  prev_sector1;
  unsigned char  prev_sector2;
  unsigned char  prev_ASD1;
  unsigned char  prev_ASD2;
  unsigned char  next_sector1;
  unsigned char  next_sector2;
  unsigned char  next_ASD1;
  unsigned char  next_ASD2;
  char           mod_type[4];         
}ASD8_tmp;

#ifdef USE_ARTE
  extern int ARTE_get_recid_DOTR(int *);
  extern int ARTE_get_feds_DOTR(int,ETB_fed *,int *);
#endif

extern int OTrDecode_SuperLayerNameToIndex(const char slname[4], unsigned char* slid) ;

OTR_Decode *OTr_Decode_init(int mode,const char *Tables_filename,
			    const char *TDC_table_filename){
FILE *TablesList,*Table,*TDCTable;
static OTR_Decode *OTR;
static int init=0;
ASD8_tmp *tmpasd[MAXASD];
unsigned short i,j,k,NLine=0;
char TableName[400],string[400];
unsigned char NLay;
unsigned short pos;
//------------------------
unsigned char crate,slot,SL=0;
int FED;
char side;
unsigned short fedline=0,Line;
int nasds ;
int VME_num,Sharc_Board,Sharc_Connector;
char link[10];
//------------------------
unsigned int igede,ngede,mono,wire;
OTrSuperLayer* slIt ;

  if(!init){
    init=1; 
  }else{  
    return OTR;
  }
  TablesList=fopen(Tables_filename,"r");
  if(TablesList==NULL){
    printf("\nError: Can't open file %s\n",Tables_filename);
    return NULL;
  }
  TDCTable=fopen(TDC_table_filename,"r"); 
  if(TDCTable==NULL){
    printf("\nError: Can't open file %s\n",TDC_table_filename);
    return NULL;
  }
  OTR=malloc(sizeof(OTR_Decode));
  if(OTR==NULL){
    printf("\nMemory allocation error...\n");
    return NULL;
  }
  for(i=0;i<MAXTDC;i++) OTR->TDCs[i]=NULL;
  for(i=0;i<MAXFED;i++) OTR->FEDs[i]=MAXFED;
  for(i=0;i<MAXASD;i++) OTR->ASD8s[i]=NULL;
  /*---------------- cabling strings loop -----------------*/  
  do{
     if(fscanf(TablesList,"%s",TableName)==EOF) break;
     Table=fopen(TableName,"r");
     if(Table==NULL){
       printf("\nError: Can't open file %s\n",TableName);
       return NULL;
     }
#ifdef __WAX_DEBUG__
     printf("OTrDecode: opened file %s \n",TableName) ;
#endif
     fgets(string,399,Table);
     do{
       if(fgets(string,399,Table)==NULL) break;
       pos=0;
       for(i=0;i<=399;i++){
         if(string[i]==0) break;
         if(string[i]=='m' ||string[i]=='p' ||string[i]=='t' ||string[i]=='s'){
	   pos++;
           if(pos==1){
             OTR->ASD8s[NLine]=malloc(sizeof(OTrASD8));
	     if(OTR->ASD8s[NLine]==NULL){
	       printf("\nMemory allocation error...\n");
	       return NULL;
	     }
	     /* initalize */
	     for(k=0;k<16;k++){
	       OTR->ASD8s[NLine]->wire[k].GEDE=0;
	       OTR->ASD8s[NLine]->wire[k].cell=0;
	     }
	     OTR->ASD8s[NLine]->TDC_FED=MAXFED ;
	     
	     tmpasd[NLine]=malloc(sizeof(ASD8_tmp));
	     if(OTR->ASD8s[NLine]==NULL){
	       printf("\nMemory allocation error...\n");
	       return NULL;
	     }
	     NLine++;
	     if(NLine==MAXASD) {
	       printf("MAXASD too small ! Cannot initialize decoding") ;
	       return NULL ;
	     }
             if(string[i]=='m') 
	       OTR->ASD8s[NLine-1]->SuperLayer=atoi(string+i+1);
             if(string[i]=='p') 
	       OTR->ASD8s[NLine-1]->SuperLayer=8+atoi(string+i+1);
             if(string[i]=='t') 
	       OTR->ASD8s[NLine-1]->SuperLayer=12+atoi(string+i+1);
             OTR->ASD8s[NLine-1]->Layer=atoi(string+i+3);
             OTR->ASD8s[NLine-1]->Sector=atoi(string+i+5);
	     tmpasd[NLine-1]->side=string[i-1];
	     if(tmpasd[NLine-1]->side=='+')
	       OTR->ASD8s[NLine-1]->SuperLayer+=16;
#ifdef __OTR_OLD_TABLES__
	     tmpasd[NLine-1]->asd_first_chan=1;
#else
	     tmpasd[NLine-1]->asd_first_chan=(atoi(string+i+8)-1)%16 + 1 ;
#endif
	   }
           if(pos==3){
             OTR->ASD8s[NLine-1]->Module=atoi(string+i+5);
             for(j=0;j<=10;j++) OTR->ASD8s[NLine-1]->hwc[j]=string[i+j-1];
             OTR->ASD8s[NLine-1]->hwc[11]=0;
	     tmpasd[NLine-1]->mod_first_wire=atoi(string+i+11);
           }
           if(pos==4){
	     tmpasd[NLine-1]->mod_last_wire=atoi(string+i+11);
           }
           if(pos==7){
             OTR->ASD8s[NLine-1]->ftb_ASD=atoi(string+i+8);
	     for(k=0;k<16;k++){ 
	       OTR->ASD8s[NLine-1]->wire[k].ASD=NLine-1;
	       OTR->ASD8s[NLine-1]->wire[k].wire=k; 
	     }
           }
           if(pos==13){
	     tmpasd[NLine-1]->crate=atoi(string+i+3);
	     tmpasd[NLine-1]->slot=atoi(string+i+5);
             OTR->ASD8s[NLine-1]->TDC_Connector=atoi(string+i+8);  
	   }
           if(pos==14){
             if(atoi(string+i+3)==0){
	       tmpasd[NLine-1]->prev_sector1=0;
	       tmpasd[NLine-1]->prev_ASD1=0;
             }else{
	       tmpasd[NLine-1]->prev_sector1=atoi(string+i+5);
	       tmpasd[NLine-1]->prev_ASD1=atoi(string+i+8);
             }
           }
           if(pos==15){
             if(atoi(string+i+3)==0){
	       tmpasd[NLine-1]->prev_sector2=0;
	       tmpasd[NLine-1]->prev_ASD2=0;
             }else{
	       tmpasd[NLine-1]->prev_sector2=atoi(string+i+5);
	       tmpasd[NLine-1]->prev_ASD2=atoi(string+i+8);
             }
           }
           if(pos==16){
             if(atoi(string+i+3)==0){
	       tmpasd[NLine-1]->next_sector1=0;
	       tmpasd[NLine-1]->next_ASD1=0;
             }else{
	       tmpasd[NLine-1]->next_sector1=atoi(string+i+5);
	       tmpasd[NLine-1]->next_ASD1=atoi(string+i+8);
             }
           }
           if(pos==17){
             if(atoi(string+i+3)==0){
	       tmpasd[NLine-1]->next_sector2=0;
	       tmpasd[NLine-1]->next_ASD2=0;
             }else{
	       tmpasd[NLine-1]->next_sector2=atoi(string+i+5);
	       tmpasd[NLine-1]->next_ASD2=atoi(string+i+8);
             }
             for(j=0;j<20;j++) if(string[i+11+j]!=' ') break;
             for(k=0;k<=2;k++) tmpasd[NLine-1]->mod_type[k]=string[i+11+j+k];
	   }
	 }
       }
     }while(1);
     fclose(Table);
  }while(1);  
  fclose(TablesList);
#ifdef __WAX_DEBUG__
  printf("OTrDecode: Read tables for %d asds.\n",NLine) ;
#endif

  /*------------- end of cabling strings loop --------------*/  
  /*------------------ start TDC-FED loop ------------------*/
  fgets(string,100,TDCTable);
  fgets(string,100,TDCTable);
  while(fgets(string,100,TDCTable)!=NULL)
    if(strlen(string) > 1 ) { /* check that line is not empty */
      if(string[1]=='m') SL=atoi(string+2);
      if(string[1]=='p') SL=8+atoi(string+2);
      if(string[1]=='t') SL=12+atoi(string+2);
      if(string[1]=='s') SL=14+atoi(string+2);
      side=string[0];
      if(side=='+') SL+=16;
      crate=atoi(string+4);
      slot=atoi(string+6);
      VME_num=0; Sharc_Board=0;
      sscanf(string+10,"%0x %i %0x %s",&FED,&VME_num,&Sharc_Board,link);
      Sharc_Connector=(atoi(link)-1)*6+atoi(link+2);
      nasds=0;
      for(i=0;i<NLine;i++) 
	if(tmpasd[i]->crate==crate && tmpasd[i]->slot==slot &&
	   tmpasd[i]->side==side && OTR->ASD8s[i]->SuperLayer==SL){  
	  OTR->ASD8s[i]->TDC_FED=FED;
	  nasds++;
	  if(OTR->FEDs[FED]!=MAXFED){
	    OTR->TDCs[OTR->FEDs[FED]]->ASD[OTR->ASD8s[i]->TDC_Connector-1]=i;
	  }else{
	    OTR->FEDs[FED]=fedline;
	    OTR->TDCs[fedline]=malloc(sizeof(OTrTDC));
	    if(OTR->TDCs[fedline]==NULL){
	      printf("\nMemory allocation error...\n");
	      return NULL;
	    }
	    for(j=0;j<8;j++) OTR->TDCs[fedline]->ASD[j]=MAXFED; 
	    OTR->TDCs[OTR->FEDs[FED]]->ASD[OTR->ASD8s[i]->TDC_Connector-1]=i;
	    OTR->TDCs[fedline]->crate = crate ;
	    OTR->TDCs[fedline]->slot  = slot ;
	    OTR->TDCs[fedline]->FED=FED;
	    if(VME_num!=0 && Sharc_Board!=0 && Sharc_Connector!=0){
	      OTR->TDCs[fedline]->VME_num=VME_num;
	      OTR->TDCs[fedline]->Sharc_Board=Sharc_Board;
	      OTR->TDCs[fedline]->Sharc_Connector=Sharc_Connector;
	    }else{
	      OTR->TDCs[fedline]->VME_num=0;
	      OTR->TDCs[fedline]->Sharc_Board=0;
	      OTR->TDCs[fedline]->Sharc_Connector=0;
	    }
	    fedline++;
	  }
	}
#ifdef __WAX_DEBUG__
      if(nasds==0) {
	printf("Error in OTrDecode: No asds found for FED %s.\n",string) ;
      }
#endif
    }
  fclose(TDCTable);
#ifdef __WAX_DEBUG__
  printf("OTrDecode: Read tables for %d tdcs.\n",fedline) ;
#endif

  /*----------------- end of TDC-FED loop ------------------*/
  /*------------- start SL,Lay,Sect,ASD loop ---------------*/
  for(i=0;i<32;i++){
    OTR->Slayers[i].NLayer=0; 
    for(k=0;k<13;k++) for(j=0;j<7;j++){
      OTR->Slayers[i].Nasd[j][k]=0; 
      OTR->Slayers[i].FirstASD[j][k]=255;
    }
  }
  for(j=0;j<NLine;j++){
    OTR->Slayers[OTR->ASD8s[j]->SuperLayer].Nasd[OTR->ASD8s[j]->Layer]
      [OTR->ASD8s[j]->Sector]++;
    if(OTR->Slayers[OTR->ASD8s[j]->SuperLayer].FirstASD[OTR->ASD8s[j]->Layer]
       [OTR->ASD8s[j]->Sector] > OTR->ASD8s[j]->ftb_ASD)
      OTR->Slayers[OTR->ASD8s[j]->SuperLayer].FirstASD[OTR->ASD8s[j]->Layer]
        [OTR->ASD8s[j]->Sector]=OTR->ASD8s[j]->ftb_ASD;
  }
  for(i=0;i<32;i++){
    NLay=0;
    pos=1;
    for(k=0;k<13;k++) for(j=0;j<7;j++){
      if(OTR->Slayers[i].FirstASD[j][k]<255){
        OTR->Slayers[i].pos[j][k]=pos;
        pos+=OTR->Slayers[i].Nasd[j][k];
	if(NLay<j) NLay=j;
      }    
    }
    OTR->Slayers[i].Line=malloc(pos*sizeof(unsigned short));
    OTR->Slayers[i].NLayer=NLay;
  }
  for(i=0;i<NLine;i++){
    OTR->Slayers[OTR->ASD8s[i]->SuperLayer].Line[
      OTR->Slayers[OTR->ASD8s[i]->SuperLayer].
      pos[OTR->ASD8s[i]->Layer][OTR->ASD8s[i]->Sector]-
      OTR->Slayers[OTR->ASD8s[i]->SuperLayer].
      FirstASD[OTR->ASD8s[i]->Layer][OTR->ASD8s[i]->Sector]+
      OTR->ASD8s[i]->ftb_ASD]=i;
  }
  /*-------------- end SL,Lay,Sect,ASD loop ----------------*/
  /*---------------------- begin GEDE ----------------------*/
#ifdef USE_ARTE
#ifdef __WAX_DEBUG__
  printf("start of asd-gede loop\n") ;
#endif
  ngede = NGEDE();
  for(igede=1; igede <= ngede; igede++){
    /* all checks after the first one are more or less equivalent */
    if(GEDE(igede).cmp==2 && GEDE(igede).sec>0 && GEDE(igede).hwc[0]!='n' && 
       GEDE(igede).hwc[11]!='n' && GEDE(igede).nsl>0) {
      unsigned char modtype,slid,layid,secid,isSpecial,isReversed;
      int subasdid;
      /*char slname[4];*/
      /*strncpy(slname,GEDE(igede).hwc,3) ;*/
      OTrDecode_SuperLayerNameToIndex(GEDE(igede).hwc,&slid) ;
      slIt =  OTR->Slayers + slid ;
      layid = GEDE(igede).lay;
      secid = GEDE(igede).sec;
      
      /* the asds in MC5 are reversed */
      isReversed = 
	!strncmp(GEDE(igede).hwc+1,"m5",2) ||
	(!strncmp(GEDE(igede).hwc,"+m6",3) && secid>6) ;
      
      /* determine module type */
      isSpecial = (secid==4) && (GEDE(igede).nwi[0]>GEDE(igede).nwi[1]);
      if(GEDE(igede).nsl==1 || GEDE(igede).nsl==2) {
	if(isSpecial)                     modtype = kOTrMT_SingleSpecial ;
	else if(GEDE(igede).hwc[0]=='-' ) modtype = kOTrMT_SingleMinus ;
	else                              modtype = kOTrMT_SinglePlus ;
      } else {
	if(isSpecial)                     modtype = kOTrMT_DoubleSpecial ;               
	else if(GEDE(igede).hwc[0]=='-' ) modtype = kOTrMT_DoubleMinus ;
	else                              modtype = kOTrMT_DoublePlus ;
      }
#ifdef __WAX_DEBUG__
      if(isSpecial)
	printf("Special module: %s\n",GEDE(igede).hwc) ;
#endif
      for(subasdid=0; subasdid<slIt->Nasd[layid][secid]; subasdid++) {
	int asdid =  slIt->Line[slIt->pos[layid][secid] + subasdid] ;
	if(!strncmp(GEDE(igede).hwc,OTR->ASD8s[asdid]->hwc,11)) {
	  for(k=0; k<16;k++) {
	    /* k+1       = channel on asd [1,16] */
	    /* modchanid = channel on module [1,...] */
	    int modchanid = 1 + tmpasd[asdid]->mod_first_wire -
	      tmpasd[asdid]->asd_first_chan ;

	    if(isReversed) modchanid += 15-k ; 
	    else           modchanid += k ;

	    /* int modchanid = k + 1 + tmpasd[asdid]->mod_first_wire -
	       tmpasd[asdid]->asd_first_chan ; */
	    
	    /* there is still one mistake in the table offsets: */
	    if(modtype==kOTrMT_SingleSpecial) ++modchanid;
	    
	    if(OTr_Decode_ASD_to_GEDE(modtype,modchanid,GEDE(igede).nwi,
				       &mono,&wire)==0) {
	      OTR->ASD8s[asdid]->wire[k].GEDE=igede;
	      OTR->ASD8s[asdid]->wire[k].cell=wire+32*mono ;
	      
	      /* the first wires of the first two monolayers of a
		 double minus are not connected by the previous
		 procedure, as the corresponding asd has a
		 different hwc. however, we can find that asd if
		 we know the first one in the module. */
	      /* something comparable holds for the last two wires of
		 the first two monolayers in a double plus. */
	      
	      if(modtype==kOTrMT_DoubleMinus) {
		if(mono==0 && wire==1) 
		  if(OTr_Decode_ASD_to_ASDindex(OTR,OTR->ASD8s[asdid]->SuperLayer,
						OTR->ASD8s[asdid]->Layer,
						tmpasd[asdid]->prev_sector1,
						tmpasd[asdid]->prev_ASD1,&Line)) {
		    OTR->ASD8s[Line]->wire[12].GEDE=igede;
		  OTR->ASD8s[Line]->wire[12].cell=0;
		  OTR->ASD8s[Line]->wire[14].GEDE=igede;
		  OTR->ASD8s[Line]->wire[14].cell=32;
		  } 
	      } else if((modtype==kOTrMT_DoublePlus || 
			 modtype==kOTrMT_DoubleSpecial) &&
			!(GEDE(igede).nwi[0]<GEDE(igede).nwi[1])) { 
		if(mono==2 && wire==GEDE(igede).nwi[2]-1)
		  if(OTr_Decode_ASD_to_ASDindex(OTR,OTR->ASD8s[asdid]->SuperLayer,
						OTR->ASD8s[asdid]->Layer,
						tmpasd[asdid]->next_sector1,
						tmpasd[asdid]->next_ASD1,&Line)){
		    OTR->ASD8s[Line]->wire[1].GEDE=igede;
		    OTR->ASD8s[Line]->wire[1].cell=32+GEDE(igede).nwi[1]-1;
		    OTR->ASD8s[Line]->wire[3].GEDE=igede;
		    OTR->ASD8s[Line]->wire[3].cell=GEDE(igede).nwi[0]-1;
		  } 
	      }	   
	    }   
	  }
	}
      }
      

    } 
  }
#ifdef __WAX_DEBUG__
  printf("OTrDecode: End of asd-gede loop.\n") ;
#endif
  /*----------------------- end GEDE -----------------------*/
#endif

  for(i=0;i<NLine;i++) free(tmpasd[i]);
  return OTR;
}

    
int OTr_Decode_TDC_to_ASD(OTR_Decode *OTR,unsigned short FED,
			  unsigned char channel,char *SL,char *Layer,
			  char *Sector,char *ASD){
unsigned short line;
   if(OTR->FEDs[FED]==MAXFED || channel>127) return 0;
   line=OTR->TDCs[OTR->FEDs[FED]]->ASD[channel/16];
   if(line==MAXFED) return 0;    
   if(OTR->ASD8s[line]!=NULL){
     *SL=OTR->ASD8s[line]->SuperLayer;
     *Layer=OTR->ASD8s[line]->Layer;
     *Sector=OTR->ASD8s[line]->Sector;
     *ASD=OTR->ASD8s[line]->ftb_ASD;
   }else return 0;
   return 1;
} 

int OTr_Decode_TDC_to_Sharc(OTR_Decode *OTR,unsigned short FED,
			    unsigned char Channel,unsigned char *VME_num,
			    unsigned char *Board_ID,unsigned short *offset){
unsigned char link;
   if(OTR->FEDs[FED]==MAXFED || Channel>127) return 0;
   *VME_num=OTR->TDCs[OTR->FEDs[FED]]->VME_num;
   *Board_ID=OTR->TDCs[OTR->FEDs[FED]]->Sharc_Board;
   link=OTR->TDCs[OTR->FEDs[FED]]->Sharc_Connector;
   if(*VME_num==0 || *Board_ID==0 || link==0) return 0;
   *offset=(link-1)*128+Channel;
   return 1;
}

int OTr_Decode_ASD_to_TDC(OTR_Decode *OTR,unsigned char SL,unsigned char Layer,
			  unsigned char Sector,unsigned char ASD,
			  unsigned short *FED,unsigned char *Conn){
unsigned short line;
  if(OTr_Decode_ASD_to_ASDindex(OTR,SL,Layer,Sector,ASD,&line)){
    *FED=OTR->ASD8s[line]->TDC_FED;
    *Conn=OTR->ASD8s[line]->TDC_Connector;
    return 1;
  }else return 0;
}

int OTr_Decode_ASD_to_ASDindex(OTR_Decode *OTR,unsigned char SL,
			       unsigned char Layer,unsigned char Sector,
			       unsigned char ASD,unsigned short *Line){
  if(Sector<1 || Sector>12 || SL<1 || SL>31 || Layer<1 
     || Layer>OTR->Slayers[SL].NLayer) return 0;
  if(ASD>(OTR->Slayers[SL].Nasd[Layer][Sector]+
	  OTR->Slayers[SL].FirstASD[Layer][Sector]-1) ||
     ASD<OTR->Slayers[SL].FirstASD[Layer][Sector]) return 0; 
  *Line=OTR->Slayers[SL].Line[OTR->Slayers[SL].pos[Layer][Sector]-
                            OTR->Slayers[SL].FirstASD[Layer][Sector]+ASD];
  if(OTR->ASD8s[*Line]==NULL) return 0;
  return 1;
}


int OTr_Decode_ASD_to_GEDE(int moduletype, int modchanid, int *wires, 
			   int *mono, int *cell) {
  int rc=0,sltwi ;
  
  /* this is the channel in the gede */
  sltwi = modchanid-1 ;
  *cell = -1;

  /* check if w>=0 (otherwise it doesn't exist) */
  if(sltwi>=0) {
    rc=0;
    switch(moduletype) {
    case kOTrMT_SingleMinus:
      *mono = (sltwi%2) ;
      *cell = sltwi/2 ;
      break;
    case kOTrMT_SinglePlus: 
      *mono = 1-(sltwi%2) ;
      *cell = sltwi/2 ;
      break;
    case kOTrMT_DoubleMinus:
      *mono = (sltwi%4) - (sltwi%4)/2 + (sltwi%4)%2 ;
      *cell = sltwi/4 - (*mono)/2 + 1 ;
      break;
    case kOTrMT_DoublePlus:
      *mono = 3 - (sltwi%4) + (sltwi%4)/2 - (sltwi%4)%2 ;
      *cell = sltwi/4 - 1 + (*mono)/2 ;
      break;
    case kOTrMT_SingleSpecial:
      *mono = 1-(sltwi%2) ;
      *cell = (sltwi-2*((sltwi+1)%2))/2 ;
      break;
    case kOTrMT_DoubleSpecial:
      *mono = 3 - (sltwi%4) + (sltwi%4)/2 - (sltwi%4)%2 ;
      *cell = (sltwi-4*(1-(sltwi%4)/2)+4)/4 -1;
      break;
    default:
      rc=-1;
    }
    /* these channels are connected to a different module */
    if(*mono < 0 || *mono>3 ||
       *cell < 0 || *cell >= wires[*mono]) rc=-1; 
  } else rc= -2 ;
  return rc ;
}

int OTr_fill_event(OTR_Decode *OTR) {
  int rc=1;

#ifdef USE_ARTE
  OTrASD8 **asdIt;
  OTrWire* chanIt ;

  int recid=0;
  static ETB_fed feds[MAXTDC];
  int Nfeds ;
 
  int i;
  unsigned short fedid;
  unsigned char *tdcdata;
  OTrTDC *tdc;
  int asdid,chanid;

  /* reset everything: set last bit of status flag to show that there
     was no data for channel processed */
  /* for status bit assignment: see waxDecodeManager::ReadStatus */
  for(asdIt=OTR->ASD8s; *asdIt != 0; asdIt++)
    for(chanIt=(*asdIt)->wire; chanIt !=(*asdIt)->wire+16 ; chanIt++) {
     chanIt->dtime = 0; /* not needed anymore: we check on status flag ... */
     chanIt->status |=  (1<<7) ; /* set last bit: channel not read ... */
     chanIt->status &= ~(1<<6) ; /* unset Maarten's bit */
    } 
  
  /* read event from DOTR bank */
  if( ((rc=ARTE_get_recid_DOTR(&recid)) == ETB_ok) &&
      ((rc=ARTE_get_feds_DOTR(MAXTDC,feds,&Nfeds)) == ETB_ok) ) {
    for(i=0;i<Nfeds;i++) {
      fedid=feds[i].hdr.fedid;
      /* check if good eventrecord and if fed connected */
      if( ((feds[i].hdr.recid & 0Xff00)==RID_NORMAL_FEDRAW) ) {
	if( (OTR->FEDs[fedid]!=MAXFED) && (tdc=OTR->TDCs[OTR->FEDs[fedid]]) ) {
	  tdcdata=(unsigned char *)feds[i].data;
	  chanid=0;
	  for(asdid=0;asdid<8;asdid++) { 
	    asdIt = OTR->ASD8s + tdc->ASD[asdid] ;
	    if(/*(tdc->ASD[asdid] != MAXASD) && */
	       (tdc->ASD[asdid] != MAXFED) 
	       && *asdIt)
	      for(chanid=0;chanid<16;chanid++) {
		(*asdIt)->wire[chanid].dtime  = tdcdata[16*asdid+chanid];
		(*asdIt)->wire[chanid].status &= ~(1<<7) ; /* unset last bit */
	      }
	  }
	}
#ifdef __WAX_DEBUG__
	else {
	  printf("OTrDecode: No tdc for FED %d .",fedid) ;
	}
#endif	
      }
#ifdef __WAX_DEBUG__
      else {
	printf("OTrDecode: Skipped FED block %d , recid = %0x",
	       fedid,feds[i].hdr.recid) ;
      }
#endif
    }
  }
#endif //USE_ARTE
  
  return rc;
}
